#!/usr/bin/perl
# -*- cperl -*-

use Tk;
use Tk::DirTree;

$language = shift || 'cz';

$treddir = $ARGV[0] || "c:\\tred";
$treddir =~ s{/}{\\}g;
$treddir =~ s{\\$}{};
$defaultvalue="C:\\tred_data";

$newvalue=$defaultvalue;
$top = MainWindow->new();

%lang = (
	 cz => {
		   'dir' => "Vyber adres pro data:",
		   'cantopen' => "nelze otevt",
		   'ok' => 'Ok',
		   'cancel' => 'Zruit',
		   'direxists1' => "Adres ",
		   'direxists2' => " neexistuje. Vytvoit?",
		   'enterdatadir' => "Zadejte adres pro datov sobory:",
		   'dektopregfail' => "Nelze zjistit adres plochy!",
		   'inst' => 'Instalace'
		  },
	 en => {
		     'dir' => "Choose data folder:",
		     'cantopen' => "Can't open",
		     'ok' => 'Ok',
		     'cancel' => 'Cancel',
		     'direxists1' => "Directory ",
		     'direxists2' => " doesn't exist. Create?",
		     'enterdatadir' => "Enter data folder:",
		     'dektopregfail' => "Can't determine Desktop folder!",
		     'inst' => 'Installation'
		    }
	);

sub getDir {
  my ($top,$curr_dir)=@_;
  my $t = $top->Toplevel;
  $t->title($lang{$language}{dir});
  $ok = 0; # flag: "1" means OK, "-1" means cancelled

  # Create Frame widget before the DirTree widget, so it's always visible
  # if the window gets resized.
  my $f = $t->Frame->pack(-fill => "x", -side => "bottom");

  my $d;
  my $inidir="/";
  my $inidir="$1\\" if $curr_dir=~/^([A-Z]:)/i;

  $d = $t->Scrolled('DirTree',
		  -scrollbars => 'osoe',
		  -width => 40,
		  -height => 40,
		  -selectmode => 'browse',
		  -exportselection => 1,
		  -directory => $inidir,
		  -dircmd => sub {
		    my( $some_dir, $showhidden ) = @_;
		    my $sdir=($some_dir=~/^[A-Z]:$/i) ? "$some_dir/" : $some_dir;
		    @dots=();
		    eval { 
		      opendir(DIR, $sdir) || die $lang{$language}{cantopen}." $some_dir: $!"; 
		      @dots=grep { -d "$some_dir/$_" } readdir(DIR);
		      closedir DIR;
		    };
		    return @dots;
		  },
		  -browsecmd => sub { $curr_dir = shift },

		  # With this version of -command a double-click will
		  # select the directory
		  -command   => sub { $ok = 1 },

		  # With this version of -command a double-click will
		  # open a directory. Selection is only possible with
		  # the Ok button.
		  #-command   => sub { $d->opencmd($_[0]) },
		 )->pack(-fill => "both", -expand => 1);
  # Set the initial directory
  $d->chdir($curr_dir) if (-d $curr_dir);
  $f->Button(-text => $lang{$language}{ok},
	     -command => sub { $ok =  1 })->pack(-side => 'left');
  $f->Button(-text => $lang{$language}{cancel},
	     -command => sub { $ok = -1 })->pack(-side => 'left');

  # You probably want to set a grab. See the Tk::FBox source code for
  # more information (search for grabCurrent, waitVariable and
  # grabRelease).
    # Set a grab and claim the focus too.
  my $oldFocus = $t->focusCurrent;
  my $oldGrab = $t->grabCurrent;
  my $grabStatus = $oldGrab->grabStatus if ($oldGrab);
  $t->grab;

  $t->waitVariable(\$ok);
  eval {
    $oldFocus->focus if $oldFocus;
  };
  if (Tk::Exists($t)) { # widget still exists
    $t->grabRelease;
    $t->withdraw;
  }
  if ($oldGrab) {
    if ($grabStatus eq 'global') {
      $oldGrab->grabGlobal;
    } else {
      $oldGrab->grab;
    }
  }
  if ($ok == 1) {
    print "$curr_dir\n";
    return $curr_dir;
  } else {
    return undef;
  }
}

$f=$top->Frame();

$e=$f->Entry(-relief => 'sunken',
	       -width => 40,
	       -takefocus => 1,
	     -background => "white",
	       -textvariable => \$newvalue);

$l = $f->Label(-text => $lang{$language}{enterdatadir},
		 -anchor => 'e',
		 -justify => 'right');
$l->pack(-side=>'top');
$e->pack(-side=>'left',-expand=>1,-fill=>'x');
#$top->resizable(0,0);
$dots=$f->Button(-text => '...',
	     -command => [ sub {
			     my $dir=getDir($top,$newvalue);
			     $newvalue=$dir if (-d $dir);
			   }])->pack(-padx=>'0.2c',-side=>'left');

$f->pack(-side=>'top',
	 -expand=>1,
	 -fill=>'both',-anchor => n);


$top->Button(-text => $lang{$language}{ok},
	     -command => [ sub {
			     return unless (defined($newvalue) and $newvalue ne "");
			     unless (-d $newvalue) {
			       mkdir $newvalue,775 if 
				 $top->messageBox(-message => 
						  $lang{$language}{direxists1}.$newvalue.
						  $lang{$language}{direxists2},
						  -title => $lang{$language}{inst}, -type => 'YesNo')
				   =~/^yes|ano$/i;
			     }
			     $top->destroy();
			   }])->pack(-padx=>'0.2c',-pady=>'0.2c',-side=>'left',-expand =>1);

$top->Button(-text => $lang{$language}{cancel},
	     -command => [ sub {
			     $newvalue=undef;
			     $top->destroy();
			   }])->pack(-padx=>'0.2c',-pady=>'0.2c',-side=>'left',-expand=>1);

$e->focus();

MainLoop;

if ($^O eq "MSWin32") {

  require Win32::Registry;
  require Win32::Shortcut;

  my %shf;

  my $ShellFolders;

  $desktop="Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders";
  $::HKEY_CURRENT_USER->Open($desktop,$ShellFolders) or die $lang{$language}{dektopregfail}." $^E\n";
  $ShellFolders->GetValues(\%shf);

  my $desktop=$shf{Desktop}[2];

  unless (-f "$desktop\\Tred.lnk") {
    $link=Win32::Shortcut->new();
    $link->{File}="$desktop\\Tred.lnk";
    $link->{Path}="$treddir\\tred.bat";
    $link->{WorkingDirectory}=$newvalue;
    $link->{Description}="Tree Editor";
    $link->{IconLocation}="$treddir\\tredlib\\tred.ico";
    $link->{IconNumber}="0";
    $link->{ShowCmd}=SW_SHOWMINNOACTIVE;
    $link->Save();
  }
}
