#!/usr/bin/perl

use ExtUtils::MakeMaker;

WriteMakefile(
	      'NAME'     => 'XML::JHXML',
	      'VERSION_FROM' => 'JHXML_include.pl',
	      'OBJECT'   => 'b4302lib.o JHXML_wrap.o',
	      'PL_FILES' => {},
	     );

sub MY::postamble {
  my $osflag=($^O eq 'MSWin32') ? 'WIN32' : 'unix';

return <<"_POSTAMLE_";

b4302lib.o: lex.b4302lib.c b4302lib.c b4302lib.h b4302libdef.h
	\$(CC) -I. \$(INC) \$(OPTIMIZE) -D\$osflag -DHB_ERROR_REPORTING -c b4302lib.c

lex.b4302lib.c: b4302libsrc.fl b4302libdef.h
	flex -t -Pb4302lib b4302libsrc.fl | \\
        perl -pe 's{^(#include <unistd.h>.*)}{#ifdef WIN32\\n#include <stdlib.h>\\n#else\\n\$\$&\\n#endif\\n}' > lex.b4302lib.c

JHXML_wrap.c: JHXML.i tools/JHXML_patch.pl JHXML_include.pl
	  swig -perl5 JHXML.i
	  perl -pi.swig tools/JHXML_patch.pl JHXML_wrap.c

_POSTAMLE_
}
