/* XML small lib test file b4302.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "b4302.h"
#include "b4302lib.h"

int callback_err(char *sz)
{
  fprintf(stderr,"%s\n",sz);
  /* supposed to exit now or later, anyway */
  return 0;
} /* of callback_err */
 
int callback_msg(char *sz)
{
  /* supposed to return and continue */
  fprintf(stderr,"%s\n",sz);
  return 0;
} /* of callback_msg */
 
main(int argc, char *argv[])
{
int iRC;
b4302DocType *pDoca;
b4302DocType *pDocb;
int c;
char szCommand[1000];
char szSTP[100000];
char szLine[4000];
char szLine2[4000];
char szCommandPref[1000];
char *pszCommand;
char *pszData;
char *szSerial;
int iRepeat;
int i;
b4302ElemType *peCurr;
b4302ElemType *pElem1;
b4302ElemType *pElemT;
b4302ElemType *pElemP;
b4302ElemType *peClipboard;
b4302AttrType *pAttrT;
b4302IOOptionsType *po;
b4302StringSListType *pssl;
b4302StringSType *psstr;

  if (argc < 3) {
    fprintf(stderr,
      "usage: b4302.x infile outfile|--noout --[no]shell [--noblanks[2]]\n");
    exit(99);
  }

  po = b4302NewOptions();

  if (argv[4] != NULL) {
    if (!strcmp(argv[4],"--noblanks2")) {
      b4302SetOptionNoBlanks(po,2);
    }
    else if (strcmp(argv[4],"--noblanks")) {
      b4302SetOptionNoBlanks(po,1);
    }
  }

  iRC = b4302ReadFile(&pDoca,argv[1],po);
  if (iRC != 0) {
    fprintf(stderr,"b4302: cannot parse input file %s.\n",argv[1]);
    exit(1);
  }
  fprintf(stderr,"b4302: %s parsed.\n",argv[1]);
  fprintf(stderr,"b4302: element nodes: %d, attributes: %d, root %s.\n",
	  pDoca->cElements,pDoca->cAttrs,pDoca->pRoot->pDown->pszName);
  /*  psstr = pDoca->sStringArea->psslStrAttr->psstrFirst;
  while (psstr != b4302psstrNULL) {
    fprintf(stderr,"Attr %s: ",psstr->szString);
    if (psstr->pslSecondary != b4302pslNULL) {
      fprintf(stderr,"%d values.",psstr->pslSecondary->cNumberOfStrings);
    }
    fprintf(stderr,"\n");
    psstr = psstr->psstrNext;
  }
  */

  /**/ /* sleep(5); /**/

  if (!strcmp(argv[3],"--shell")) { 
    /* show that it works: */

    pElem1 = b4302DocGetRootElement(pDoca); /* start in root element */
    /* pElem1 is always the current element */
    while (gets(szCommand) != NULL) {
      if (strchr(szCommand,' ') != NULL) {
	strcpy(szCommandPref,szCommand);
	pszCommand = strchr(szCommandPref,' ');
	*pszCommand++ = '\0';
	iRepeat = atoi(szCommandPref);
      }
      else { iRepeat = 1; pszCommand = szCommand; }
      if (!strcmp(pszCommand,"quit") || 
	  !strcmp(pszCommand,"exit") || 
	  !strcmp(pszCommand,"bye")) {
	break;
      }
      for (i = 1; i <= iRepeat; i++) {
	if (!strcmp(pszCommand,"pwd")) {
	  pElemT = pElem1;
	  while (pElemT != NULL) {
	    if (i == iRepeat) {
	      fprintf(stdout,"...up: %s",pElemT->pszName);
	      if (*(pElemT->pszName) == '<') { 
		fprintf(stdout,"TEXT>"); 
		fprintf(stdout,"%s",(char *)(pElemT->pDown));
	      }
	      else if (b4302NodeIsComment(pElemT)) { 
		fprintf(stdout,"%s",(char *)(pElemT->pDown));
	      }
	      else if (b4302NodeIsCDATA(pElemT)) { 
		fprintf(stdout,"%s</CDATA>",(char *)(pElemT->pDown));
	      }
	      fprintf(stdout,"\n");
	    }
	    pElemT = pElemT->pParent;
	  }
	} /* of pwd */
	else if (!strcmp(pszCommand,"down")) {
	  pElemT = b4302GetFirstChild(pElem1);
	  if (pElemT == NULL) {
	    if (b4302NodeIsElement(pElem1)) {
	      fprintf(stderr,"Current elem (%s) is a leaf; cannot go down.\n",pElem1->pszName);
	      break;
	    }
	    else {
	      fprintf(stderr,"Current DOM node is a text leaf; cannot go down.\n");
	      break;
	    }
	  }
	  else {
	    pElem1 = pElemT;
	    if (i == iRepeat) {
	      fprintf(stdout,"...now at: %s",pElem1->pszName);
	      if (b4302NodeIsText(pElem1)) {
		fprintf(stdout,"TEXT>"); 
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsComment(pElem1)) {
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsCDATA(pElem1)) { 
		fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	      }
	      fprintf(stdout,"\n");
	    }
	  }
	}
	else if (!strcmp(pszCommand,"last")) {
	  pElemT = b4302GetLastChild(pElem1);
	  if (pElemT == NULL) {
	    if (!b4302NodeIsText(pElem1)) {
	      fprintf(stderr,"Current elem (%s) is a leaf; cannot go down to last child.\n",
		      pElem1->pszName);
	      break;
	    }
	    else {
	      fprintf(stderr,"Current DOM node is a text leaf; cannot go down to last child.\n");
	      break;
	    }
	  }
	  else {
	    pElem1 = pElemT;
            fprintf(stdout,"...now at: %s",pElem1->pszName);
	    if (b4302NodeIsText(pElem1)) {
	      fprintf(stdout,"TEXT>"); 
	      fprintf(stdout,"%s",(char *)(pElem1->pDown));
	    }
	    else if (b4302NodeIsComment(pElem1)) {
	      fprintf(stdout,"%s",(char *)(pElem1->pDown));
	    }
	    else if (b4302NodeIsCDATA(pElem1)) { 
	      fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	    }
	    fprintf(stdout,"\n");
	    break; /* does not make sence to repeat iRepeat times anyway! */
	  }
	}
	else if (!strcmp(pszCommand,"up")) {
	  pElemT = b4302GetParent(pElem1);
	  if (pElemT == NULL) {
	    fprintf(stderr,"Current elem (%s) is the root; cannot go up.\n",pElem1->pszName);
	    break;
	  }
	  else {
	    pElem1 = pElemT;
	    if (i == iRepeat) {
	      fprintf(stdout,"...now at: %s\n",pElem1->pszName);
	    }
	  }
	} /* of up */
	else if (!strcmp(pszCommand,"right") || !strcmp(pszCommand,"next")) {
	  pElemT = b4302GetNextElement(pElem1);
	  if (pElemT == NULL) {
	    fprintf(stderr,"Current elem (%s) has no right brother.\n",pElem1->pszName);
	    break;
	  }
	  else {
	    pElem1 = pElemT;
	    if (i == iRepeat) {
	      fprintf(stdout,"...now at: %s",pElem1->pszName);
	      if (*(pElem1->pszName) == '<') {
		fprintf(stdout,"TEXT>"); 
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsComment(pElem1)) {
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsCDATA(pElem1)) { 
		fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	      }
	      fprintf(stdout,"\n");
	    }
	  }
	} /* of next/right */
	else if (!strcmp(pszCommand,"left") || !strcmp(pszCommand,"prev")) {
	  /* this is ok if left pointer(s) set: */
	  pElemT = b4302GetPrevElement(pElem1);
	  if (pElemT == NULL) {
	    fprintf(stderr,"Current elem (%s) has no left brother.\n",pElem1->pszName);
	    break;
	  }
	  else {
	    pElem1 = pElemT;
	    if (i == iRepeat) {
	      fprintf(stdout,"...now at: %s",pElem1->pszName);
	      if (b4302NodeIsText(pElem1)) {
		fprintf(stdout,"TEXT>"); 
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsComment(pElem1)) {
		fprintf(stdout,"%s",(char *)(pElem1->pDown));
	      }
	      else if (b4302NodeIsCDATA(pElem1)) { 
		fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	      }
	      fprintf(stdout,"\n");
	    }
	  }
	  /* this is good if *only right* pointers set: 
	     inefficient for large tree levels: */
	  /* 
	     pElemT = pElem1->pParent;
	     if (pElemT == NULL) {
	     fprintf(stderr,"Current elem (%s) has no left brother.\n",
	     pElem1->pszName);
	     break;
	     }
	     else {
	     pElemT = pElemT->pDown;
	     if (pElemT == pElem1) {
	     fprintf(stderr,"Current elem (%s) has no left brother.\n",
	     pElem1->pszName);
	     break;
	     }
	     else {
	     pElemP = pElemT;
	     pElemT = pElemP->pNext;
	     while (pElemT != pElem1) { pElemP = pElemT; 
	     pElemT = pElemP->pNext; }
	     pElem1 = pElemP;
	     if (i == iRepeat) {
	     fprintf(stdout,"...now at: %s",pElem1->pszName);
	     if (*(pElem1->pszName) == '<') {
	     fprintf(stdout,"TEXT>"); 
	     fprintf(stdout,"%s",(char *)(pElem1->pDown));
	     }
	     else if (b4302NodeIsComment(pElem1)) {
	     fprintf(stdout,"%s",(char *)(pElem1->pDown));
	     }
	     else if (b4302NodeIsCDATA(pElem1)) { 
	     fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	     }

	     fprintf(stdout,"\n");
	     }
	     }
	     }
	  */
	} /* of prev/left */
	else if (!strcmp(pszCommand,"attrs") || 
		 !strcmp(pszCommand,"attributes")) {
	  pAttrT = b4302GetFirstAttr(pElem1);
	  if (pAttrT == NULL) {
	    fprintf(stderr,"No attributes at element %s\n",pElem1->pszName);
	  }
	  while (pAttrT != NULL) {
	    fprintf(stdout,"%s = \"%s\"\n",pAttrT->pszName,pAttrT->pszValue);
	    pAttrT = b4302GetNextAttr(pAttrT);
	  }
	}
	else if (!strcmp(pszCommand,"setattr") || 
		 !strcmp(pszCommand,"setattribute")) {
	  gets(szLine);
	  gets(szLine2);
	  pAttrT = b4302SetAttribute(pElem1,szLine,szLine2);
	  if (pAttrT == NULL) {
	    fprintf(stderr,"cannot set attr %s of %s with %s.\n",
		    szLine,pElem1->pszName,szLine2);
	  }	
	  break;
	}
	else if (!strcmp(pszCommand,"getattr") || 
		 !strcmp(pszCommand,"getattribute")) {
	  gets(szLine);
	  pszData = b4302GetAttribute(pElem1,szLine);
	  if (pszData == NULL) {
	    fprintf(stderr,"cannot get attr %s of %s.\n",
		    szLine,pElem1->pszName);
	  }	
	  else {
	    fprintf(stderr,"attr value: %s\n",pszData);
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"data")) {
	  pszData = b4302GetData(pElem1);
	  if (pszData == NULL) {
	    fprintf(stderr,"cannot get data of %s (?!?!).\n",
		    pElem1->pszName);
	  }	
	  else {
	    fprintf(stderr,"data of %s: %s\n",pElem1->pParent->pszName,pszData);
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"append")) {
	  gets(szLine);
	  peCurr = b4302AppendText(pElem1,szLine);
	  if (peCurr == NULL) {
	    fprintf(stderr,"cannot append text %s to %s (?!?!).\n",
		    szLine,pElem1->pszName);
	  }	
	  else {
	    fprintf(stderr,"appended as last child of %s: %s\n",
		    pElem1->pszName,(char *)(peCurr->pDown));
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"appendchild") ||
		 !strcmp(pszCommand,"ac")) {
	  gets(szLine);
	  gets(szLine2);
	  peCurr = b4302AppendTextChild(pElem1,szLine,szLine2);
	  if (peCurr == NULL) {
	    fprintf(stderr,
		    "cannot append node/text <%s>%s</%s> to %s (?!?!).\n",
		    szLine,szLine2,szLine,pElem1->pszName);
	  }	
	  else {
	    fprintf(stderr,"appended as last child of %s: <%s>%s</%s>\n",
		    pElem1->pszName,
		    peCurr->pszName,
		    (char *)(peCurr->pDown->pDown),
		    peCurr->pszName);
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"remove") ||
		 !strcmp(pszCommand,"rm")) {
	  pElemP = pElem1->pNext;
	  if (pElemP == NULL) {
	    pElemP = pElem1->pLeft;
	  }
	  if (pElemP == NULL) {
	    pElemP = pElem1->pParent;
	    if (pElemP == NULL || b4302NodeIsVirtualRoot(pElemP)) {
	      fprintf(stderr,"cannot remove root.\n");
	      break;
	    }
	  }
	  peCurr = b4302RemoveChild(pElem1->pParent,pElem1);
	  if (peCurr == b4302peNULL) {
	    fprintf(stderr,
		    "cannot remove %s (?!?!).\n",
		    pElem1->pszName);
	    break;
	  }	
	  peClipboard = peCurr;
	  pElem1 = pElemP;
	}
	else if (!strcmp(pszCommand,"copy") ||
		 !strcmp(pszCommand,"cp")) {
	  peClipboard = pElem1;
	  break;
	}
	else if (!strcmp(pszCommand,"import")) {
	  if (peClipboard == b4302peNULL) {
	    fprintf(stderr,"Empty clipboard.\n");
	  }
	  else {
	    if (0 != b4302BindFragment(pDoca,peClipboard->pParent)) {
	      fprintf(stderr,"Cannot import fragment %s from clipboard.\n",
		      peClipboard->pszName);
	    }
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"clipboard") ||
		 !strcmp(pszCommand,"cb")) {
	  if (peClipboard != b4302peNULL) {
	    fprintf(stderr,"clipboard: %s\n",peClipboard->pszName);
	  }
	  else {
	    fprintf(stderr,"Empty clipboard.\n");
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"replace")) {
          if (b4302NodeIsVirtualRoot(pElem1)) {
	    fprintf(stderr,"cannot paste at virtual root.\n");
	    break; 
	  }
	  pElemT = pElem1->pParent;
	  peCurr = b4302ReplaceChild(pElem1->pParent, 
				     peClipboard,pElem1);
	  if (peCurr != b4302peNULL) {
	    pElem1 = peClipboard;
	    peClipboard = peCurr;
	  }
	  else {
	    fprintf(stderr,"replace %s by %s not success.\n",
		    pElem1->pszName,peClipboard->pszName);
	    pElem1 = pElemT;
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"removeattribute") ||
		 !strcmp(pszCommand,"rmattr")) {
	  gets(szLine);
	  iRC = b4302RemoveAttribute(pElem1,szLine);
	  if (iRC > 0) {
	    fprintf(stderr,
		    "cannot remove attr %s (?!?!).\n",
		    szLine);
	    break;
	  }	
	  break;
	}
	else if (!strcmp(pszCommand,"file")) {
	  gets(szLine);
	  fprintf(stderr,"Destroying open document...\n");
	  if (pDoca != b4302pdNULL) {
	    b4302DestroyDoc(pDoca);
	    pDoca = b4302pdNULL;
	  }
	  fprintf(stderr,"Reading %s...\n",szLine);
	  iRC = b4302ReadFile(&pDoca,szLine,po);
	  if (iRC != 0) {
	    fprintf(stderr,"b4302: cannot parse input file %s.\n",szLine);
	    exit(11);
	  }
	  fprintf(stderr,"b4302: %s parsed.\n",szLine);
	  fprintf(stderr,
		  "b4302: element nodes: %d, attributes: %d, root %s.\n",
		  pDoca->cElements,pDoca->cAttrs,pDoca->pRoot->pDown->pszName);
	  pElem1 = b4302DocGetRootElement(pDoca); /* start in root element */
	  break;
	}
	else if (!strcmp(pszCommand,"findc") ||
		 !strcmp(pszCommand,"findn") ||
		 !strcmp(pszCommand,"findp") ||
		 !strcmp(pszCommand,"finda")) {
	  gets(szLine);
	  pElemP = pElem1;

	  if (!strcmp(pszCommand,"findc")) {
	    pElem1 = b4302FindFirstChild(pElem1,szLine);
	  }
	  else if (!strcmp(pszCommand,"findn")) {
	    pElem1 = b4302FindNextSibling(pElem1,szLine);
	  }
	  else if (!strcmp(pszCommand,"findp")) {
	    pElem1 = b4302FindPrevSibling(pElem1,szLine);
	  }
	  else if (!strcmp(pszCommand,"finda")) {
	    pElem1 = b4302FindAncestor(pElem1,szLine);
	  }

	  if (pElem1 == b4302peNULL) {
	    fprintf(stderr,"%s not found\n",szLine);
	    pElem1 = pElemP;
	  }
	  else {
	    fprintf(stdout,"found: %s",pElem1->pszName);
	    if (*(pElem1->pszName) == '<') { 
	      fprintf(stdout,"TEXT>"); 
	      fprintf(stdout,"%s",(char *)(pElem1->pDown));
	    }
	    else if (b4302NodeIsComment(pElem1)) {
	      fprintf(stdout,"%s",(char *)(pElem1->pDown));
	    }
	    else if (b4302NodeIsCDATA(pElem1)) { 
	      fprintf(stdout,"%s</CDATA>",(char *)(pElem1->pDown));
	    }
	    fprintf(stdout,"\n");
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"write")) {
	  gets(szLine);
	  iRC = b4302WriteFile(pDoca,szLine);
	  if (iRC != 0) {
	    fprintf(stderr,"b4302: cannot write output file %s.\n",szLine);
	    exit(22);
	  } 
	  b4302DestroyDoc(pDoca);
	  fprintf(stderr,"file %s written and doc destroyed.\n",szLine);
	  pDoca = b4302pdNULL;
	  pElem1 = NULL;
	  break;
	}
	else if (!strcmp(pszCommand,"deltree")) {
	  pElemP = pElem1->pParent;
	  if (pElemP == NULL || b4302NodeIsVirtualRoot(pElemP)) {
	    fprintf(stderr,"cannot destroy root.\n");
	    break;
	  }
	  peCurr = b4302RemoveChild(pElem1->pParent,pElem1);
	  if (peCurr == NULL) {
	    fprintf(stderr,
		    "cannot remove %s (?!?!).\n",
		    pElem1->pszName);
	    break;
	  }	
	  iRC = b4302DestroySubtree(peCurr);
	  if (iRC != 0) {
	    fprintf(stderr,
		    "cannot destroy subtree.\n");
	    break;
	  }	
	  pElem1 = pElemP;
	  break;
	}
	else if (!strcmp(pszCommand,"deldoc")) {
	  if (pDoca != b4302pdNULL) {
            iRC = b4302DestroyDoc(pDoca);
	  }
	  if (iRC != 0) {
	    fprintf(stderr,"cannot destroy document.\n");
	    break;
	  }
	  pDoca = NULL;
	  pElem1 = NULL;
	  break;
	}
	else if (!strcmp(pszCommand,"lr")) {
	  szSerial = b4302ToString(pElem1);
	  if (szSerial == NULL) {
	    fprintf(stderr,"ERROR\n");
	  }
	  else {
	    fprintf(stderr,"%s\n",szSerial);
	    free(szSerial);
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"parse")) {
	  *szSTP = '\0';
	  while (gets(szLine) != NULL && strlen(szLine) != 0) {
	    strcat(szSTP,szLine);
	    strcat(szSTP,"\n");
	  }
	  pDocb = b4302ParseString(szSTP,po);
	  if (pDocb == NULL) {
	    fprintf(stderr,"cannot parse string %s.\n",szSTP);
	    break;
	  }
	  else {
	    pElem1 = b4302DocGetRootElement(pDocb); /* start in root element */
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"parsedoc")) {
	  *szSTP = '\0';
	  while (gets(szLine) != NULL && strlen(szLine) != 0) {
	    strcat(szSTP,szLine);
	    strcat(szSTP,"\n");
	  }
	  pElem1 = b4302DocParseString(pDoca,szSTP);
	  if (pElem1 == NULL) {
	    fprintf(stderr,"cannot parse string %s (current doc).\n",szSTP);
	    break;
	  }
	  break;
	}
	else if (!strcmp(pszCommand,"back")) {
	  pElem1 = b4302DocGetRootElement(pDoca); /* start in root element
						     of orig file */
	  break;
	}
	else if (!strcmp(pszCommand,"errorok")) {
	  b4302SetOptionParseErrorsOK(po,1);
	  break;
	}
	else if (!strcmp(pszCommand,"noerror")) {
	  b4302SetOptionParseErrorsOK(po,0);
	  break;
	}
	else if (!strcmp(pszCommand,"noblanks")) {
	  b4302SetOptionNoBlanks(po,1);
	  break;
	}
	else if (!strcmp(pszCommand,"noblanksaggressive")) {
	  b4302SetOptionNoBlanks(po,2);
	  break;
	}
	else if (!strcmp(pszCommand,"blanks")) {
	  b4302SetOptionNoBlanks(po,0);
	  break;
	}
	else if (!strcmp(pszCommand,"indent")) {
	  gets(szLine);
	  b4302SetOptionIndent(po,atoi(szLine));
	  break;
	}
	else if (!strcmp(pszCommand,"fragments")) {
	  pElemT = pDoca->peFirstFragment;
	  while (pElemT != b4302peNULL) {
	    fprintf(stderr,"fragment root name: %s.\n",pElemT->pDown->pszName);
	    pElemT = pElemT->pNext;
	  }
	  po->fParseErrorsOK = 0;
	  break;
	}
	else if (!strcmp(pszCommand,"help")) {
	  fprintf(stderr,"%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s%s",
		  "help\n",
		  "[n] down\n",
		  "[n] up\n",
		  "pwd\n",
		  "[n] next/right\n",
		  "[n] left/prev\n",
		  "last\n",
		  "parse\n",
		  "parsedoc\n",
		  "back\n",
		  "attrs\n",
		  "clipboard/cb\n",
		  "copy/cp\n",
		  "import\n",
		  "getattr/getattribute\n",
		  "setattr/setattribute\n",
		  "data\n",
		  "replace\n",
		  "append\n",
		  "appendchild/ac\n",
		  "[n] remove/rm\n",
		  "findc\n",
		  "findn\n",
		  "findp\n",
		  "finda\n",
		  "deltree\n",
		  "deldoc\n",
		  "file\n",
		  "write\n",
		  "errorok\n",
		  "noerror\n",
		  "noblanks\n",
		  "noblanksaggressive\n",
		  "blanks\n",
		  "indent\n",
		  "lr\n",
		  "fragments\n",
		  "import\n",
		  "removeattribute/rmattr\n",
		  "bye/quit/exit\n");
	  break;
	}
	else {
	  fprintf(stderr,"ERROR: wrong command: %s\n",pszCommand);
	  break;
	}
      } /* of for i till iRepeat */
    } /* end of "shell" */
  } /* of shell */

  if (strcmp(argv[2],"--noout")) {
    if (pDoca != NULL) {
      iRC = b4302WriteFile(pDoca,argv[2]);
      if (iRC != 0) {
        fprintf(stderr,"b4302: cannot write output file %s.\n",argv[2]);
        exit(2);
      }
    } 
  }

  free(po);

  return iRC;
} /* of main - test */


