/* XML small lib b4302lib.c */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "b4302lib.h"

#define MODULE "b4302lib"

char szMsg[10000];

extern int callback_err(char *sz);

#define peNULL b4302peNULL
#define paNULL b4302paNULL
#define pdNULL b4302pdNULL
#define pstrNULL b4302pstrNULL
#define pslNULL b4302pslNULL
#define psstrNULL b4302psstrNULL
#define psslNULL b4302psslNULL
#define psaNULL b4302psaNULL
#define psiNULL b4302psiNULL
#define poNULL b4302poNULL
#define cNULL b4302cNULL
 
#define peDown pDown
#define peParent pParent
#define peLeft pLeft
#define peNext pNext
#define paNext pNext

#define ERRMSG(rc,s) { \
   sprintf(szMsg,"%s: %s",MODULE,s); \
   callback_err(szMsg); \
   return(rc); }

#define ERRMSGFS(rc,f,s) { \
   sprintf(szMsg,f,MODULE,s); \
   callback_err(szMsg); \
   return(rc); }

#define ERRMSGFD(rc,f,d) { \
   sprintf(szMsg,f,MODULE,d); \
   callback_err(szMsg); \
   return(rc); }

#define ERRMSGFSD(rc,f,s,d) { \
   sprintf(szMsg,f,MODULE,s,d); \
   callback_err(szMsg); \
   return(rc); }

#define ERRMSGFSS(rc,f,s,sb) { \
   sprintf(szMsg,f,MODULE,s,sb); \
   callback_err(szMsg); \
   return(rc); }

#define MSG(s) { \
   sprintf(szMsg,"%s: %s",MODULE,s); \
   callback_msg(szMsg); }

#define MSGFS(f,s) { \
   sprintf(szMsg,f,MODULE,s); \
   callback_msg(szMsg); }

#define MSGFD(f,d) { \
   sprintf(szMsg,f,MODULE,d); \
   callback_msg(szMsg); }

#define MSGFSD(f,s,d) { \
   sprintf(szMsg,f,MODULE,s,d); \
   callback_msg(szMsg); }

#define MSGFSS(f,s,sb) { \
   sprintf(szMsg,f,MODULE,s,sb); \
   callback_msg(szMsg); }

#include "lex.b4302lib.c"

/* macros for document fragment handling: */
#define SET_DOC_OF_VROOT(pevr,pd) pevr->pAttrFirst = (b4302AttrType *) pd
#define DOC_OF_VROOT(pevr) (b4302DocType *) pevr->pAttrFirst
#define GET_DOC_OF_VROOT(pd,pevr) pd = (b4302DocType *) pevr->pAttrFirst
#define PUSH_FRAGMENT(pd,pevr) {\
  if (pd->peFirstFragment != peNULL) { pd->peFirstFragment->pLeft = pevr; }\
  pevr->peNext = pd->peFirstFragment;\
  pd->peFirstFragment = pevr;\
  /* make the just removed fragment point to the original document: */\
  SET_DOC_OF_VROOT(pevr,pd); /* must cast */ }

#define b4302ListLengthOptimal(psl) (psl == pslNULL || \
                                     psl->cNumberOfStrings < 35)

#define b4302HASHCODE(s) (*s == '\0' ? (0) : ((*s + s[1]) & b4302HASHMASK))
#define b4302SHASHCODE(s) (*s == '\0' ? (0) : ((*s + s[1]) & b4302SHASHMASK))

/* global variables for flex communication: */
char *pszb4302Text;
int cb4302Len;
b4302Events eb4302Token;

/* global, externally accessible: */
static int b4302fParsing = 0; /* set when input file is opened; 
			serves as a flag that prevents opening 
			two files/parsing two strings concurrently */	

/* private: */
int b4302UnlinkFragment(b4302ElemType *peVR)
{
  /* unlink fragment from its document; do not destroy anything, do
     not destroy the fragment itself, not even the virtual root node! */
  /* intended use: when moving subtrees between documents */
b4302ElemType *peLeftVR;
b4302ElemType *peNextVR;
b4302DocType *pdCurr;

  if (peVR == peNULL ||
      !b4302NodeIsVirtualRoot(peVR)) { return 1; } 
  peLeftVR = peVR->peLeft;
  peNextVR = peVR->peNext;
  if (peLeftVR == peNULL) {
    pdCurr = DOC_OF_VROOT(peVR);
    pdCurr->peFirstFragment = peNextVR;
  }
  else {
    peLeftVR->peNext = peNextVR;
  }
  if (peNextVR != peNULL) {
    peNextVR->peLeft = peLeftVR;
  }
  peVR->peNext = peNULL;
  peVR->peLeft = peNULL;
  /* keep parent (doc) for now */
  return 0;
} /* of b4302UnlinkFragment */

int b4302BindFragment(b4302DocType *pd, b4302ElemType *peVR)
{
  /* unlink fragment from original document (if different), and
     link it to the new document fragmetn list. */
int iRC;
  if (pd == pdNULL || peVR == peNULL ||
      !b4302NodeIsVirtualRoot(peVR)) { return 1; } 
  if (pd == DOC_OF_VROOT(peVR)) { return 0; /* nothing to do - same doc */ }
  /* unlink fragment from its current document: */
  if (0 != (iRC = b4302UnlinkFragment(peVR))) {
    ERRMSG(2,"Cannot unlink fragment.");
  }
  /***/ /* here we should do something about NS I guess... */
  /* link into another document: */
  PUSH_FRAGMENT(pd,peVR);
  return 0;
} /* b4302BindFragment */

int
b4302StripBeg(char **ppszStr)
{
int iRC;
char *pch;
  iRC = 0;
  pch = *ppszStr;
  while (*pch != '\0') {
    if (*pch != ' ' && *pch != '\t' && *pch != '\n') {
      break;
    }
    iRC = 1;
    pch++;
  }
  *ppszStr = pch;
  return iRC;
} /* of b4302StripBeg */
 
inline int
b4302AllBlanks(char *pszStr)
{
char *pch;
  pch = pszStr;
  while (*pch != '\0') {
    if (*pch != ' ' && *pch != '\t' && *pch != '\n' && *pch != 13) {
      return 0;
    }
    pch++;
  }
  return 1; /* all blanks (or empty string) */
} /* of b4302AllBlanks */
 
void
b4302StripEnd(char *pszStr)
{
char *pch;
int cLen;
  cLen = strlen(pszStr);
  pch = pszStr + cLen; /* ptr to final '\0' */
  while (pch != pszStr) {
    pch--;
    if (*pch != ' ' && *pch != '\t' && *pch != '\n') {
      pch++;
      break;
    }
  }
  *pch = '\0';
} /* of b4302StripEnd */

int
b4302AddSZ(char **pszStart, int *pcCurrentLength,
	   char **ppszFree, int *pcRemaining, 
	   char *pszToAdd, int cLengthToAdd)
{
  /* add string pszToAdd at the end of pszStart; reallocate if length
     insufficient; update all lengths and pointers */
int iIncrLen = 4000;
int cNewLen;

  if (*pszStart == cNULL ||
	 cLengthToAdd > *pcRemaining) {
    /* must reallocate */
    if (*pszStart == cNULL) {
      *pcCurrentLength = 0; /* initialize string length for first call */
    }
    cNewLen = *pcCurrentLength + cLengthToAdd + iIncrLen; /* leave some room */
    *pszStart = (char *) realloc(*pszStart,cNewLen * sizeof(char));
    if (*pszStart == cNULL) {
      ERRMSGFD(1,"%s: Cannot reallocate string, len = %d.",cNewLen);
    }
    *pcRemaining = cNewLen - *pcCurrentLength - 1;
    *ppszFree = *pszStart + *pcCurrentLength;
  } /* of incrementing length */
  /****/ /* strcpy(*ppszFree,"");
	    fprintf(stderr,"adding %s to %s, remaining before %d.\n",pszToAdd,
				      *pszStart,*pcRemaining); /**/
  strcpy(*ppszFree,pszToAdd);
  (*ppszFree) += cLengthToAdd;
  (*pcCurrentLength) += cLengthToAdd;
  (*pcRemaining) -= cLengthToAdd;
  return 0;
} /* of b4302AddSZ */

int
b4302NewString(b4302StringType **ppString)
{
int iRC;
b4302StringType *pString;
  if (NULL == (pString = (b4302StringType *) malloc(sizeof(b4302StringType)))) {
    ERRMSG(1,"cannot allocate memory for b4302StringType."); }
  pString->szString = NULL;
  pString->pNext = NULL;
  *ppString = pString;
  return 0;
} /* of b4302NewString */

int
b4302NewStringList(b4302StringListType **ppStringList)
{
int iRC;
b4302StringListType *pStringList;
int i;

  if (NULL == (pStringList = 
	       (b4302StringListType *) malloc(sizeof(b4302StringListType)))) {
    ERRMSG(1,"cannot allocate memory for b4302StringListType.");
  }
  pStringList->cNumberOfStrings = 0;
  for (i = 0; i < b4302HASHMAX; i++) {
    pStringList->pFirst[i] = pstrNULL;
  }
  *ppStringList = pStringList;
  return 0;
} /* of b4302NewStringList */

int
b4302NewStringS(b4302StringSType **ppString)
{
int iRC;
b4302StringSType *pString;
  if (psstrNULL == 
      (pString = (b4302StringSType *) malloc(sizeof(b4302StringSType)))) {
    ERRMSG(1,"cannot allocate memory for b4302StringSType."); }
  pString->szString = cNULL;
  pString->pslSecondary = pslNULL;
  pString->psstrNext = psstrNULL;
  *ppString = pString;
  return 0;
} /* of b4302NewStringS */

int
b4302NewStringSList(b4302StringSListType **ppStringSList)
{
int iRC;
b4302StringSListType *pStringSList;
int i;

  if (psslNULL == 
      (pStringSList = 
       (b4302StringSListType *) malloc(sizeof(b4302StringSListType)))) {
    ERRMSG(1,"cannot allocate memory for b4302StringSListType.");
  }
  pStringSList->csstrNumberOfStrings = 0;
  for (i = 0; i < b4302SHASHMAX; i++) {
    pStringSList->psstrFirst[i] = psstrNULL;
  }
  *ppStringSList = pStringSList;
  return 0;
} /* of b4302NewStringSList */

int
b4302NewStringArea(b4302StringAreaType **ppStringArea)
{
int iRC;
b4302StringAreaType *pStringArea;
  if (NULL == (pStringArea = 
	       (b4302StringAreaType *) malloc(sizeof(b4302StringAreaType)))) {
    fprintf(stderr,"%s: cannot allocate memory for b4302StringAreaType.\n",
	    MODULE);
    return 1;
  }
  if (0 != (iRC = b4302NewStringList(&(pStringArea->pStrElem)))) {
    fprintf(stderr,"%s: cannot allocate memory for elem list.\n",MODULE);
    return 2;
  }
  if (0 != (iRC = b4302NewStringSList(&(pStringArea->psslStrAttr)))) {
    fprintf(stderr,"%s: cannot allocate memory for attr Slist.\n",MODULE);
    return 3;
  }
  *ppStringArea = pStringArea;
  return 0;
} /* of b4302NewStringArea */

char *b4302AllocString(char *pszStringNew)
{
  /* alloc new string */
char *szText;
int cNewLen;

  cNewLen = strlen(pszStringNew);
  if (cNULL == (szText = (char *) malloc(sizeof(char)*(cNewLen+1)))) {
    ERRMSGFD(cNULL,
	     "%s: cannot allocate memory for string in alloc, len = %d\n",
	     cNewLen);
  }
  strcpy(szText,pszStringNew);
  return szText;
} /* of AllocString */

char *b4302AllocString2(char *pszStringNew, char *pszStringNew2)
{
  /* alloc new string as a concatenation of 2 param strings */
char *szText;
int cNewLen;

  cNewLen = strlen(pszStringNew) + strlen(pszStringNew2);
  if (cNULL == (szText = (char *) malloc(sizeof(char)*(cNewLen+1)))) {
    ERRMSGFD(cNULL,
	     "%s: cannot allocate memory for string.2 in alloc, len = %d\n",
	     cNewLen);
  }
  strcpy(szText,pszStringNew);
  strcat(szText,pszStringNew2);
  return szText;
} /* of AllocString2 */

char *b4302ReallocString(char *pszStringOrig, char *pszStringNew)
{
  /* free and alloc if new string longer than original;
     copy over if shorter */
char *szText;
int cNewLen;

  cNewLen = strlen(pszStringNew);
  if (strlen(pszStringOrig) >= cNewLen) {
    strcpy(pszStringOrig,pszStringNew);
    return pszStringOrig;
  }
  else {
    free(pszStringOrig);
    if (cNULL == (szText = (char *) malloc(sizeof(char)*(cNewLen+1)))) {
      ERRMSGFD(cNULL,
	       "%s: cannot allocate memory for string in realloc, len = %d\n",
	       cNewLen);
    }
    strcpy(szText,pszStringNew);
    return szText;
  }
} /* of ReallocString */

int
b4302AllocateDoc(b4302DocType **ppDoc)
{
int iRC;
b4302DocType *pDoc;
  if (*ppDoc == NULL) {
    pDoc = (b4302DocType *) malloc(sizeof(b4302DocType));
    if (pDoc == NULL) {
      fprintf(stderr,"%s: cannot allocate document record.\n",MODULE);
      return 1;
    }
    pDoc->poCurr = b4302NewOptions();
    pDoc->pRoot = peNULL;
    pDoc->peFirstFragment = peNULL;
    pDoc->pParsingStack = psiNULL;
    if (0 != (iRC = b4302NewStringArea(&(pDoc->sStringArea)))) {
      fprintf(stderr,"%s: cannot allocate memory for string area.\n",MODULE);
      return 2;
    }
    pDoc->pszCurrentFile = cNULL;
    pDoc->pszName = "";
    pDoc->fDocIn = NULL;
    pDoc->fDocOut = NULL;
    pDoc->cElements = 0;
    pDoc->cAttrs = 0;
    pDoc->szXML = cNULL;
    pDoc->szDocument = cNULL;
    pDoc->fDocumentIncompleteAfterParse = 0;
    *ppDoc = pDoc;
  }
  return 0;
} /* of b4302AllocateDoc */

int
b4302OpenFile(b4302DocType *pDoc, char *pszFileName, char *pszFlags)
{
int iRC;
FILE *f;
  if (pDoc == pdNULL) {
    ERRMSGFS(8,"%s: cannot open file %s for nonexisting document.",
	     pszFileName);
  }
  if (pDoc->fDocOut != NULL) {
    ERRMSGFSS(6,"%s: cannot open file %s when %s is open for writing.",
	     pszFileName,pDoc->pszCurrentFile);
  }
  if (pDoc->fDocIn != NULL) {
    ERRMSGFSS(7,"%s: cannot open file %s when %s is open for reading.",
	     pszFileName,pDoc->pszCurrentFile);
  }
  if ((!strcmp(pszFlags,"r") ||
       !strcmp(pszFlags,"rt")) &&
      (!strcmp(pszFileName,"STDIN") ||
       !strcmp(pszFileName,"-"))) {
    if (b4302fParsing == 1) {
      ERRMSGFS(3,"%s: cannot open two files for parsing (2nd attempted: %s)",
	       pszFileName);
    }
    pDoc->fDocIn = stdin;
    pDoc->fDocOut = NULL;
    pDoc->pszCurrentFile = "STDIN";
  }
  else if ((!strcmp(pszFlags,"w") ||
       !strcmp(pszFlags,"wt")) &&
      (!strcmp(pszFileName,"STDOUT") ||
       !strcmp(pszFileName,"-"))) {
    pDoc->fDocIn = stdout;
    pDoc->fDocOut = NULL;
    pDoc->pszCurrentFile = "STDOUT";
  }
  else if (!strcmp(pszFileName,"STDIN") ||
           !strcmp(pszFileName,"STDOUT") ||
           !strcmp(pszFileName,"-")) {
    fprintf(stderr,"%s: Wrong combination of parameters for OpenFile: %s %s\n",
	    MODULE,pszFileName,pszFlags);
    return 1;
  }
  else {
    f = fopen(pszFileName,pszFlags);
    if (f == NULL) {
      fprintf(stderr,"%s: cannot open document file %s\n",
	      MODULE,pszFileName);
      return 2;
    }
    if (strlen(pszFlags) >= 1) {
      if (pszFlags[0] == 'w' ||
	  pszFlags[0] == 'a') {
	pDoc->fDocOut = f;
        pDoc->fDocIn = NULL;
      }
      else {
	if (b4302fParsing == 1) {
	  ERRMSGFS(4,
		   "%s: cannot open two files for parsing (2nd attempted: %s)",
		   pszFileName);
	}
	pDoc->fDocIn = f;
	pDoc->fDocOut = NULL;
      }
    }
    else { 
      if (b4302fParsing == 1) {
	ERRMSGFS(5,
		 "%s: cannot open two files for parsing (2nd attempted: %s)",
		 pszFileName);
      }
      pDoc->fDocIn = f;
      pDoc->fDocOut = NULL;
    }
    pDoc->pszCurrentFile = pszFileName;
  }
  return 0;
} /* of b4302OpenFile */

inline int /* calls the flex scanner to get next token, 
       uses 3 globals for output params */
b4302NextEvent(void)
{ 
  eb4302Token = b4302liblex();
  pszb4302Text = b4302libtext;
  cb4302Len = b4302libleng;
  if (eb4302Token == XEOF) {
    return 1;
  }
  else if (eb4302Token == XERROR) {
    return -1;
  }
  else {
    return 0;
  }
} /* of b4302NextEvent */

inline int
b4302NewElem(b4302ElemType **ppElem)
{
int iRC;
b4302ElemType *pElem;
  if (NULL == (pElem = (b4302ElemType *) malloc(sizeof(b4302ElemType)))) {
    fprintf(stderr,"%s: cannot allocate memory for b4302ElemType.\n",MODULE);
    return 1;
  }
  pElem->pszName = (char *) NULL;
  /* pElem->pszPrefix = NULL; */
  /* pElem->pszNSID = NULL; */
  pElem->pAttrFirst = (b4302AttrType *) NULL;
  pElem->pNext = (b4302ElemType *) NULL;
  pElem->pDown = (b4302ElemType *) NULL;
  pElem->pParent = (b4302ElemType *) NULL;
  pElem->pLeft = (b4302ElemType *) NULL;
  /* pElem->pLastSon = NULL; */
  *ppElem = pElem;
  return 0;
} /* of b4302NewElem */

inline int
b4302NewAttr(b4302AttrType **ppAttr)
{
int iRC;
b4302AttrType *pAttr;
  if (NULL == (pAttr = (b4302AttrType *) malloc(sizeof(b4302AttrType)))) {
    fprintf(stderr,"%s: cannot allocate memory for b4302AttrType.\n",MODULE);
    return 1;
  }
  pAttr->pszName = (char *) NULL;
  /* pAttr->pszPrefix = NULL; */
  /* pAttr->pszNSID = NULL; */
  pAttr->pszValue = cNULL;
  pAttr->pNext = paNULL;
  pAttr->pMyElem = peNULL;
  *ppAttr = pAttr;
  return 0;
} /* of b4302NewAttr */

inline char * /* find string, return pointer to it; add if fAdd set */
       /* fAdd set: returns NULL if allocation problem
          fAdd not set: returns NULL if not found */
pszb4302GetStrPtr(b4302StringListType *psl, 
		  char *pszStringToFind, int fAdd)
{
int iRC;
b4302StringType *pstr;
int iHash;
  /* search for the string: */
  if (psl == pslNULL) {
    return cNULL;
  }
  iHash = b4302HASHCODE(pszStringToFind);
  pstr = psl->pFirst[iHash];
  while (pstr != NULL) {
    /****/ /* fprintf(stderr,"strptr: comparing %s.\n",pstr->szString); /**/
    if (!strcmp(pstr->szString,pszStringToFind)) { /* found */
      return pstr->szString;
    }
    pstr = pstr->pNext;
  }
  /* not found */
  if (fAdd == ADDSTRING) {
    if (0 != (iRC = b4302NewString(&pstr))) {
      fprintf(stderr,"%s: cannot allocate new string record.\n",
	      MODULE);
      return cNULL;
    }
    if (NULL == (pstr->szString = 
		 (char *) malloc(sizeof(char)*(strlen(pszStringToFind)+1)))) {
      fprintf(stderr,"%s: cannot allocate memory for string, len = %d.\n",
	      MODULE,strlen(pszStringToFind));
      return cNULL;
    }
    strcpy(pstr->szString,pszStringToFind); /* copy the string to the newly
					       allocated space */
    pstr->pNext = psl->pFirst[iHash]; /* link it backwards */
    psl->pFirst[iHash] = pstr;
    psl->cNumberOfStrings++;
    /****/ /* fprintf(stderr,"ADDED STRING: %s\n",pstr->szString); /**/
    return pstr->szString;
  }
  else { /* fAdd == SEARCHONLY assumed */
    return NULL;
  }
} /* of pszb4302GetStrPtr */

/* find psstr record with string, return pointer to it; add if fAdd set */
/* fAdd set: returns NULL if allocation problem
   fAdd not set: returns NULL if not found */
/* this is for the primary string of the primary/sec version of StringSList */
inline b4302StringSType *psstrb4302GetStrSPtr(b4302StringSListType *pssl, 
					      char *pszStringToFind, int fAdd)
{
int iRC;
b4302StringSType *psstr;
int iHash;
  /* search for the string: */
  if (pssl == psslNULL || pszStringToFind == cNULL) {
    return psstrNULL;
  }
  iHash = b4302SHASHCODE(pszStringToFind);
  psstr = pssl->psstrFirst[iHash];
  while (psstr != psstrNULL) {
    if (!strcmp(psstr->szString,pszStringToFind)) { /* found */
      return psstr;
    }
    psstr = psstr->psstrNext;
  }
  /* not found */
  if (fAdd == ADDSTRING) {
    if (0 != (iRC = b4302NewStringS(&psstr))) {
      fprintf(stderr,"%s: cannot allocate new stringS record.\n",
	      MODULE);
      return psstrNULL;
    }
    if (cNULL == (psstr->szString = 
		 (char *) malloc(sizeof(char)*(strlen(pszStringToFind)+1)))) {
      fprintf(stderr,"%s: cannot allocate memory for stringS, len = %d.\n",
	      MODULE,strlen(pszStringToFind));
      return psstrNULL;
    }
    strcpy(psstr->szString,pszStringToFind); /* copy the string to the newly
					       allocated space */
    psstr->psstrNext = pssl->psstrFirst[iHash]; /* link it backwards */
    pssl->psstrFirst[iHash] = psstr;
    pssl->csstrNumberOfStrings++;
    /****/ /* fprintf(stderr,"ADEDD STRING: %s\n",psstr->szString); /**/
    return psstr;
  }
  else { /* fAdd == SEARCHONLY assumed */
    return psstrNULL;
  }
} /* of psstrb4302GetStrSPtr */

inline char * /* find string, return pointer to it; add if fAdd set */
              /* fAdd set: returns NULL if allocation problem
		 fAdd not set: returns NULL if not found */
/* this is for the primary string of the primary/sec version of StringSList */
pszb4302GetStrSPtr(b4302StringSListType *pssl, 
		  char *pszStringToFind, int fAdd)
{
b4302StringSType *psstr;

  psstr = psstrb4302GetStrSPtr(pssl,pszStringToFind,fAdd);
  if (psstr == psstrNULL) {
    return cNULL;
  }
  else {
    return psstr->szString;
  }
} /* of pszb4302GetStrSPtr */

inline char * /* find string in secondary list of primary StringS, 
		 return pointer to it; add if fAdd set */
       /* fAdd set: returns NULL if allocation problem
          fAdd not set: returns NULL if not found */
pszb4302GetStrSRefPtr(b4302StringSType *psstr, char *pszStringToFind, int fAdd)
{
int iRC;
b4302StringListType *psl;
char *pszStr2;
int iHash;
  if (psstr == psstrNULL) { return cNULL; }
  psl = psstr->pslSecondary;
  if (fAdd == ADDSTRING) { /* adding string */
    /****/ /* fprintf(stderr,"adding %s.\n",pszStringToFind); /**/
    pszStr2 = pszb4302GetStrPtr(psl,pszStringToFind,SEARCHONLY);  
    if (pszStr2 != cNULL) {
      /****/ /* fprintf(stderr,"found at %x\n",pszStr2); /**/
      return pszStr2; /* found! */
    }
    /* not found: */
    if (b4302ListLengthOptimal(psl)) { /* still worth putting into the list */
      /* allocate list head if not yet done: */
      if (psl == pslNULL) {
	/****/ /* fprintf(stderr,"ALLOCating psl.\n"); /**/
	if (0 != (iRC = b4302NewStringList(&psl))) {
	  ERRMSGFS(cNULL,"%s: cannot allocate memory for AV list (%s=...).\n",
		   psstr->szString);
	}
	psstr->pslSecondary = psl;
      }
      /* add it: */
      pszStr2 = pszb4302GetStrPtr(psl,pszStringToFind,fAdd);
      /****/ /* fprintf(stderr,"added to stored list (%s) [%x].\n",
		     pszStringToFind,pszStr2); /**/
      return pszStr2;
    }
    else {
      /* too long list already: allocate in global area: */
      if (cNULL == (pszStr2 = (char *) 
		    malloc(sizeof(char)*(strlen(pszStringToFind)+1)))) {
	ERRMSGFD(cNULL,"%s: cannot allocate memory for stringS2, len = %d.\n",
		 strlen(pszStringToFind));
      }
      strcpy(pszStr2,pszStringToFind); /* copy the string to the newly
					  allocated space */
      /****/ /* fprintf(stderr,"allocated in global area (%s).\n",
		     pszStringToFind); /**/
      return pszStr2;
    }
  }
  else { /* search only, do not add even if not found: */
    pszStr2 = pszb4302GetStrPtr(psl,pszStringToFind,fAdd);  
    return pszStr2;
  }
} /* of pszb4302GetStrSRefPtr */

inline char * /* find string in secondary list of primary StringS, 
		 return pointer to it; add if fAdd set */
       /* fAdd set: returns NULL if allocation problem
          fAdd not set: returns NULL if not found */
pszb4302GetStrS2Ptr(b4302StringSListType *pssl, 
		    char *pszStringPrimary, char *pszStringToFind, int fAdd)
{
int iRC;
b4302StringListType *psl;
b4302StringSType *psstr;
char *pszStr2;
int iHash;
  /* search for the string: */
  iHash = b4302SHASHCODE(pszStringPrimary);
  psstr = pssl->psstrFirst[iHash];
  /****/ /* fprintf(stderr,"searching for %s, secondary %s, hash %d.\n",
	    pszStringPrimary,pszStringToFind,iHash); /**/
  while (psstr != psstrNULL) {
    /****/ /* fprintf(stderr,"strS2ptr: search for attr name; comparing %s.\n",
	      psstr->szString); /**/
    if (!strcmp(psstr->szString,pszStringPrimary)) { /* found */
      break;
    }
    psstr = psstr->psstrNext;
  }
  if (psstr == psstrNULL) { /* primary string not found, error -> exit */
    return cNULL;
  }
  /* found, pointer in psstr: */
  return pszb4302GetStrSRefPtr(psstr,pszStringToFind,fAdd);
} /* of pszb4302GetStrS2Ptr */

inline int
b4302NewStackItem(b4302StackItemType **ppsiNew)
{
int iRC;
b4302StackItemType *psiNew;

  if (NULL == (psiNew = (b4302StackItemType *) 
	       malloc(sizeof(b4302StackItemType)))) {
    fprintf(stderr,"%s: cannot allocate memory for b4302StackItemType.\n",
	    MODULE);
    return 1;
  }
  psiNew->pNext = NULL;
  psiNew->pLastElem = NULL;
  *ppsiNew = psiNew;
  /****/ /* fprintf(stderr,"Allocated stack item: addr %x\n",psiNew); /**/
  return 0;
} /* of b4302NewStackItem */

int /* link element to the parsing stack, and to the doc tree being built */
b4302LinkElement(b4302DocType *pDoc, b4302ElemType *pElemCurr) {
int iRC;
b4302ElemType *pElem;
b4302StackItemType *psiRoot;
b4302StackItemType *psi;
b4302StackItemType *psiNext;

  if (pDoc->pParsingStack == psiNULL) { /* we are at the root of 
					the document tree;
					this is the first element
					in the document! */
    /* allocate item for the document root: */
    if (0 != (iRC = b4302NewStackItem(&psiRoot))) {
      fprintf(stderr,
       "%s: cannot allocate memory for root stack item in b4302LinkElement.\n",
	      MODULE);
      return 1;
    }
    pDoc->pRoot->pDown =
      pElemCurr; /* remember the (actual) root of document permanently */
    pElemCurr->pParent = pDoc->pRoot; /* point to virtual root */
    psiRoot->pLastElem = pElemCurr; /* stack item: root pointer */
    /****/ /* fprintf(stderr,"added %s as root of document, parent %s.\n",
		   pElemCurr->pszName,pDoc->pRoot->pszName); /**/
    pDoc->pParsingStack = psiRoot;
    /* pNext stays NULL, signalling bottom of stack */
    /* allocate item for the next item (first son of root): */    
    if (0 != (iRC = b4302NewStackItem(&psi))) {
      fprintf(stderr,
	      "%s: cannot allocate memory for stack item in b4302LinkElement (2).\n",
	      MODULE);
      return 2;
    }
    psi->pNext = pDoc->pParsingStack; /* link stack item to root item */
    /* pLastElem stays NULL to signal empty level */
    pDoc->pParsingStack = psi; /* move top of stack */
  }
  else { /* parsing stack already has something in it */

    /****/ /* fprintf(stderr,"adding %s, root of document: %s, parent %s.\n",
		   pElemCurr->pszName,
		   pDoc->pRoot->pDown->pszName,pDoc->pRoot->pszName); /**/

    psi = pDoc->pParsingStack; /* top of stack */
    if (psi->pLastElem == NULL) { /* should go to first son of next item
				     on stack */
      /* link elements correctly: first the elements themselves */
      psiNext = psi->pNext;
      if (psiNext == NULL) { /* error - should not link at level zero! (there
				should be only one root element in document) */
	fprintf(stderr,"%s: two roots in a document.\n",MODULE);
	return 3;
      }
      else { /* ok, next item on stack exists: */
	/* two assertions first: */
        if (psiNext->pLastElem == NULL) {
	  fprintf(stderr,"%s: internal error: psiNext->pLastElem == NULL\n",MODULE);
	  return 4;
	}
	if (psiNext->pLastElem->pDown != NULL) {
	  fprintf(stderr,
		  "%s: internal error: psiNext->pLastElem->pDown != NULL\n",
		  MODULE);
	  return 5;
	}
	/* it is the parent of the current element to-be-added: */
	psiNext->pLastElem->pDown = pElemCurr; /* first son link */
	pElemCurr->pParent = psiNext->pLastElem; /* link up */
	/****/ /* fprintf(stderr,"added %s as 1st son of %s.\n",
		       pElemCurr->pszName,pElemCurr->pParent->pszName); /**/
	psi->pLastElem = pElemCurr; /* fill in the stack item 
				       with current elem */
	/* create empty "first son" item on the stack: */
	psiNext = psi; /* current top of stack becoming second */
	if (0 != (iRC = b4302NewStackItem(&psi))) {
	  fprintf(stderr,
           "%s: cannot allocate mem for stack item in b4302LinkElement (6).\n",
		  MODULE);
	  return 6;
	}
	psi->pNext = psiNext;
	/* pLastElem stays NULL to signal empty level */
	pDoc->pParsingStack = psi; /* move top of stack */
      } /* of next item on stack exists */
    } /* of pLastElem == NULL */
    else { /* going on same level as top of stack, has to create stack item: */
      /* only link the new thing in: */
      /* elements as such: */
      pElemCurr->pParent = psi->pLastElem->pParent; /* copy parent pointer */
      psi->pLastElem->pNext = pElemCurr; /* link new element to previous */
      pElemCurr->pLeft = psi->pLastElem; /* link for going to the 
					    left efficiently */
      /* change top-of-stack pointer to new elem: */
      /****/ /* fprintf(stderr,"added %s after %s under %s.\n",
		     pElemCurr->pszName,psi->pLastElem->pszName,
		     pElemCurr->pParent->pszName); /**/
      psi->pLastElem = pElemCurr;
      /* create empty "first son" item on the stack: */
      psiNext = psi; /* current top of stack becoming second */
      if (0 != (iRC = b4302NewStackItem(&psi))) {
	fprintf(stderr,
         "%s: cannot allocate mem for stack item in b4302LinkElement (11).\n",
		MODULE);
	return 11;
      }
      psi->pNext = psiNext;
      /* pLastElem stays NULL to signal empty level */
      pDoc->pParsingStack = psi; /* move top of stack */
    } /* extending current level to the right... */
  } /* of parsing stack nonempty - not a root elem */
  return 0;
} /* of b4302LinkElement */

inline int
b4302PopElement(b4302DocType *pDoc) {
int iRC;
b4302ElemType *pElem;
b4302StackItemType *psiRoot;
b4302StackItemType *psi;
b4302StackItemType *psiNext;

  psi = pDoc->pParsingStack; /* top of stack */
  if (psi == NULL) {
    fprintf(stderr,"%s: internal error: cannot pop empty stack.\n",MODULE);
    return 1;
  }
  psiNext = psi->pNext;
  /****/ /* if (psi->pLastElem == NULL) {
         fprintf(stderr,"popping empty element from stack.\n"); }
  else { 
    fprintf(stderr,"popping %s from stack.\n",psi->pLastElem->pszName); } /**/
  free(psi);
  pDoc->pParsingStack = psiNext; /* new top of stack */
  return 0;
} /* b4302PopElement */

int
b4302FreeParsingStack(b4302DocType *pd)
{
int iRC;
  /* free unused portion of stack: */
  while (pd->pParsingStack != psiNULL) {
    if (0 != (iRC = b4302PopElement(pd))) {
      ERRMSGFS(1,"%s: Error freeing unused stack: %s.",pd->pszCurrentFile);
    }
  } /* of while: freeing unused part of stack */
  return 0;
} /* of b4302FreeParsingStack */

inline int /* convert external attr val string to internal */
b4302InternalAttrValue(char *szText, char *psz4302Text) {
  /* for now, takes care of beg/end quotes and char refs and 
     basic 4 ents only */
  /* assumes start/end quotes ok and match checked already 
     by the lex scanner! */
  /* ...and of course that szText is large enough! */
int iRC;
char *pchText;
char *pchTextIn;
char chQuote;
char ch;
char *pchEntIn;
int iCharRef;
int iBase;
char szEnt[1000];
char *pchEnt;
char *pszEnt;
char *pszCR; /* char ref entity start */
char *pchEntEnd;

  pchTextIn = psz4302Text;
  pchText = szText;
  *szText = '\0';
  chQuote = *pchTextIn;
  pchTextIn++;


  /* #define FAST */
#ifdef FAST
  /* for speed: */
  if (/***/ /* code is utf-8 */ 1) { /* no coding required */
    if (strchr(pchTextIn,'&') == NULL) { /* no entity in string */
      /* copy and remove trailing quote: */
      strcpy(pchText,pchTextIn);
      pchText[strlen(pchText)-1] = '\0';
      return 0;
    }
  }
#endif

  pchTextIn++; /* *after* next char */

  while (*pchTextIn != '\0') {
    ch = *(pchTextIn-1);
    if (ch == '&') { /* entity ref */
      pchEnt = szEnt;
      pchEntEnd = pchEnt + 998;
      while (*pchTextIn != '\0' && *pchTextIn != ';') {
	if (pchEnt == pchEntEnd) {
	  *pchEnt = '\0';
	  fprintf(stderr,"%s: entity name too long: %s\n",MODULE,szEnt);
	  return 1;
	} 
	*pchEnt++ = *pchTextIn++;
      }
      *pchEnt = '\0';
      if (*pchTextIn != ';') {
	fprintf(stderr,"%s: entity name not closed: %s\n",MODULE,szEnt);
	return 2;
      }
      pchTextIn++; /* skip the semicolon; next char will be skipped at end of
		      while loop, which is ok, because we work on pchTextIn-1! */
      if (*szEnt == '#') { /* character ref */
	pszCR = szEnt + 1;
	if (*pszCR == 'x') { /* hex */ iBase = 16; pszCR++; }
	else { /* dec */ iBase = 10; }
	pchEnt = pszCR;
	iCharRef = 0;
	while (*pchEnt != '\0') {
	  if (iBase == 10) {
	    if (*pchEnt >= '0' && *pchEnt <= '9') {
	      iCharRef = iCharRef*iBase + (*pchEnt - '0');
	    }
	    else {
	      fprintf(stderr,"%s: not a dec digit: %s\n",MODULE,szEnt);
	      return 3;
	    }
	  }
	  else { /* hex */
	    if (*pchEnt >= '0' && *pchEnt <= '9') {
	      iCharRef = iCharRef*iBase + (*pchEnt - '0');
	    }
	    else if (*pchEnt >= 'A' && *pchEnt <= 'F') {
	      iCharRef = iCharRef*iBase + (*pchEnt - 'A' + 10);
	    }
	    else if (*pchEnt >= 'a' && *pchEnt <= 'f') {
	      iCharRef = iCharRef*iBase + (*pchEnt - 'a' + 10);
	    }
	    else {
	      fprintf(stderr,"%s: not a hex digit: %s\n",MODULE,szEnt);
	      return 4;
	    }
	  }
	  pchEnt++;
	} /* end of analyzing char ref */
	if (iCharRef < 256) { /* should check for more, like space, ctrl ... */
	  *pchText++ = (unsigned char) iCharRef;
	}
	else { /* it's a UTF code... */
	  *pchText++ = (unsigned char) (iCharRef / 256);
	  *pchText++ = (unsigned char) (iCharRef % 256);
	}
      } /* end of char ref netity processing */
      else { /* "ordinary" entity */
	if (!strcmp(szEnt,"amp")) {
	  *pchText++ = '&';
	}
	else if (!strcmp(szEnt,"quot")) {
	  *pchText++ = '"';
	}
	else if (!strcmp(szEnt,"apos")) {
	  *pchText++ = '\'';
	}
	else if (!strcmp(szEnt,"lt")) {
	  *pchText++ = '<';
	}
	else if (!strcmp(szEnt,"gt")) {
	  *pchText++ = '>';
	}
	/***/ /* should check for ent name form DTD if any! */
	else {
	  *pchText++ = '&';
	  pchEnt = szEnt;
	  while (*pchEnt != '\0') {
	    *pchText++ = *pchEnt++;
	  }
	  *pchText++ = ';';
	} /* of unrecognized entity name */
      }
    } /* of entity ref ('&') found at beg */
    else { /* ordinary char */ /***/ /* shoud do conversion here (iso/utf/etc.) */
      *pchText++ = ch;
    }
    pchTextIn++;
  } /* of while not end of pchTextIn */
  *pchText = '\0';
  return 0;
} /* of b4302InternalAttrValue */

inline int /* convert external attr val string to internal */
b4302ToInternalText(char *szText, char *psz4302Text) {
  /* for now, takes care of char refs and basic 4 ents only */
  /* assumes that szText is large enough! */
int iRC;
char *pchText;
char *pchTextIn;
char ch;
char *pchEntIn;
int iCharRef;
int iBase;
char szEnt[1000];
char *pchEnt;
char *pszEnt;
char *pszCR; /* char ref entity start */
char *pchEntEnd;

  pchTextIn = psz4302Text;
  pchText = szText;
  *szText = '\0';

  /* #define FAST */
#ifdef FAST
  /* for speed: */
  if (/***/ /* code is utf-8 */ 1) { /* no coding required */
    if (strchr(pchTextIn,'&') == NULL) { /* no entity in string */
      /* copy and remove trailing quote: */
      strcpy(pchText,pchTextIn);
      pchText[strlen(pchText)-1] = '\0';
      return 0;
    }
  }
#endif

  while (*pchTextIn != '\0') {
    ch = *(pchTextIn);
    if (ch == '&') { /* entity ref */
      pchEnt = szEnt;
      pchEntEnd = pchEnt + 998;
      pchTextIn++; /* skip the amp */
      while (*pchTextIn != '\0' && *pchTextIn != ';') {
	if (pchEnt == pchEntEnd) {
	  *pchEnt = '\0';
	  fprintf(stderr,"%s: entity name too long: %s\n",MODULE,szEnt);
	  return 1;
	} 
	*pchEnt++ = *pchTextIn++;
      }
      *pchEnt = '\0';
      if (*pchTextIn != ';') {
	ERRMSGFS(2,"%s: entity name not closed: %s",szEnt);
      }
      if (*szEnt == '#') { /* character ref */
	pszCR = szEnt + 1;
	if (*pszCR == 'x') { /* hex */ iBase = 16; pszCR++; }
	else { /* dec */ iBase = 10; }
	pchEnt = pszCR;
	iCharRef = 0;
	while (*pchEnt != '\0') {
	  if (iBase == 10) {
	    if (*pchEnt >= '0' && *pchEnt <= '9') {
	      iCharRef = iCharRef*iBase + (*pchEnt - '0');
	    }
	    else {
	      ERRMSGFS(3,"%s: not a dec digit: %s",szEnt);
	    }
	  }
	  else { /* hex */
	    if (*pchEnt >= '0' && *pchEnt <= '9') {
	      iCharRef = iCharRef*iBase + (*pchEnt - '0');
	    }
	    else if (*pchEnt >= 'A' && *pchEnt <= 'F') {
	      iCharRef = iCharRef*iBase + (*pchEnt - 'A' + 10);
	    }
	    else if (*pchEnt >= 'a' && *pchEnt <= 'f') {
	      iCharRef = iCharRef*iBase + (*pchEnt - 'a' + 10);
	    }
	    else {
	      ERRMSGFS(4,"%s: not a hex digit: %s",szEnt);
	    }
	  }
	  pchEnt++;
	} /* end of analyzing char ref */
	if (iCharRef < 256) { /* should check for more, like space, ctrl ... */
	  *pchText++ = (unsigned char) iCharRef;
	}
	else { /* it's a UTF code... */
	  *pchText++ = (unsigned char) (iCharRef / 256);
	  *pchText++ = (unsigned char) (iCharRef % 256);
	}
      } /* end of char ref entity processing */
      else { /* "ordinary" entity */
	if (!strcmp(szEnt,"amp")) {
	  *pchText++ = '&';
	}
	else if (!strcmp(szEnt,"quot")) {
	  *pchText++ = '"';
	}
	else if (!strcmp(szEnt,"apos")) {
	  *pchText++ = '\'';
	}
	else if (!strcmp(szEnt,"lt")) {
	  *pchText++ = '<';
	}
	else if (!strcmp(szEnt,"gt")) {
	  *pchText++ = '>';
	}
	/***/ /* should check for ent name form DTD if any! */
	else {
	  *pchText++ = '&';
	  pchEnt = szEnt;
	  while (*pchEnt != '\0') {
	    *pchText++ = *pchEnt++;
	  }
	  *pchText++ = ';';
	} /* of unrecognized entity name */
      }
    } /* of entity ref ('&') found at beg */
    else { /* ordinary char */ 
      /***/ /* should do conversion here (iso/utf/etc.) */
      *pchText++ = ch;
    }
    pchTextIn++;
  } /* of while not end of pchTextIn */
  *pchText = '\0';
  return 0;
} /* of b4302ToInternalText */

int
b4302AttrValueToString(char *pszValue,
		       char **pszStart, int *pcCurrentLength,
		       char **ppszFree, int *pcRemaining) 
{
int iRC;
unsigned char *pchIn;
char szCharOut[10];
char szNum[19];

#define APPEND(rc,s) if (0 != (iRC = b4302AddSZ(pszStart,pcCurrentLength,\
			ppszFree,pcRemaining,s,strlen(s)))) {\
                        ERRMSGFS(rc,"%s: cannot add str %s.",s); }

  szCharOut[1] = '\0';
  pchIn = (unsigned char *) pszValue;
  while (*pchIn != '\0') {
    if (*pchIn < 128) { /* ascii, check for forbidden chars */
      if (*pchIn == '\"') {
	APPEND(1,"&quot;");
      }
      else if (*pchIn == '&') {
	APPEND(2,"&amp;");
      }
      else if (*pchIn == '<') {
	APPEND(3,"&lt;");
      }
      else if (*pchIn == '>') {
	APPEND(4,"&gt;");
      }
      /*
      else if (*pchIn == '\'') {
	APPEND(5,"&apos;");
      }
      */
      else { /* just the symbol */
	if (*pchIn >= 32) { /* space and over is ok */
	  szCharOut[0] = *pchIn;
	  APPEND(6,szCharOut);
	}
	else { /* output char ref */
	  sprintf(szNum,"&#x%X;",*pchIn);
	  APPEND(7,szNum);
	}
      }
    }
    else { /* utf code */
      szCharOut[0] = *pchIn;
      APPEND(8,szCharOut);
    }
    pchIn++;
  }
  return 0; 
#undef APPEND
} /* of b4302AttrValueToString */

int
b4302TextToString(char *pszValue,
		       char **pszStart, int *pcCurrentLength,
		       char **ppszFree, int *pcRemaining) 
{
  /* for now, let it be exactly as AttrValueToString; 
     xmllint behaves the same way, ie. without apos */
int iRC;
unsigned char *pchIn;
char szCharOut[10];
char szNum[19];

#define APPEND(rc,s) if (0 != (iRC = b4302AddSZ(pszStart,pcCurrentLength,\
			ppszFree,pcRemaining,s,strlen(s)))) {\
                        ERRMSGFS(rc,"%s: cannot add str %s.",s); }

  if (cNULL == pszValue) {
    ERRMSG(9,"Cannot TextToString: null text (cNULL).");
  }
  szCharOut[1] = '\0';
  pchIn = (unsigned char *) pszValue;
  APPEND(10,"");
  while (*pchIn != '\0') {
    if (*pchIn < 128) { /* ascii, check for forbidden chars */
      if (*pchIn == '\"') {
	APPEND(1,"&quot;");
      }
      else if (*pchIn == '&') {
	APPEND(2,"&amp;");
      }
      else if (*pchIn == '<') {
	APPEND(3,"&lt;");
      }
      else if (*pchIn == '>') {
	APPEND(4,"&gt;");
      }
      /*
      else if (*pchIn == '\'') {
	APPEND(5,"&apos;");
      }
      */
      else { /* just the symbol */
	if (*pchIn >= 32 || *pchIn == 9 || *pchIn == 10) { 
	  /* space and over is ok, so is tab and newline */
	  szCharOut[0] = *pchIn;
	  APPEND(6,szCharOut);
	}
	else { /* output char ref */
	  sprintf(szNum,"&#x%X;",*pchIn);
	  APPEND(7,szNum);
	}
      }
    }
    else { /* utf code */
      szCharOut[0] = *pchIn;
      APPEND(8,szCharOut);
    }
    pchIn++;
  }
  return 0; 
#undef APPEND
} /* of b4302TextToString */

int
b4302WriteAttrValue(b4302DocType *pDoc, char *pszValue)
{
int iRC;
unsigned char *pchIn;
char szValOut[4000];
char *pchOut;
char *pchOutEnd;
char szNum[14];

  pchOut = szValOut;
  pchOutEnd = pchOut + 3990;
  pchIn = (unsigned char *) pszValue;
  while (*pchIn != '\0') {
    if (pchOut >= pchOutEnd) {
      /* not enough space in output string */
      *pchOut = '\0';
      return 1;
    }
    if (*pchIn < 128) { /* ascii, check for forbidden chars */
      if (*pchIn == '\"') {
	strcpy(pchOut,"&quot;");
	pchOut += 6;
      }
      else if (*pchIn == '&') {
	strcpy(pchOut,"&amp;");
	pchOut += 5;
      }
      else if (*pchIn == '<') {
	strcpy(pchOut,"&lt;");
	pchOut += 4;
      }
      else if (*pchIn == '>') {
	strcpy(pchOut,"&gt;");
	pchOut += 4;
      }
      /* ignore this: single quote ok within double quotes
      else if (*pchIn == '\'') {
	strcpy(pchOut,"&apos;");
	pchOut += 6;
      }
      */
      else { /* just the symbol */
	if (*pchIn >= 32) { /* space and over is ok */
	  *pchOut++ = *pchIn;
	}
	else { /* output char ref */
	  *pchOut++ = '&';
	  *pchOut++ = '#';
	  sprintf(szNum,"x%X",*pchIn);
	  strcpy(pchOut,szNum);
	  pchOut += strlen(szNum);
	  *pchOut++ = ';';
	}
      }
    }
    else { /* utf code */
      /***/ /* should analyze it according to output coding -- this
	       code here works only for utf input/output! */
      *pchOut++ = *pchIn;
    }
    pchIn++;
  }
  *pchOut = '\0';
  fprintf(pDoc->fDocOut,"%s",szValOut);
  return 0; 
} /* of b4302WriteAttrValue */

inline void
b4302QuickIndent(FILE *f, int i)
{
int iIndentRemains;
 iIndentRemains = i;
 while (iIndentRemains > 8) {
   fprintf(f,"        ");
   iIndentRemains -= 8;
 }
 while (iIndentRemains > 4) {
   fprintf(f,"    ");
   iIndentRemains -= 4;
 }
 while (iIndentRemains > 2) {
   fprintf(f,"  ");
   iIndentRemains -= 2;
 }
 while (iIndentRemains > 0) {
   fprintf(f," ");
   iIndentRemains--;
 }
} /* of b4302QuickIndent */

int
b4302WriteLevel(b4302DocType *pDoc, b4302ElemType *pElem, 
		int fCurrentMayIndent, int iCurrentIndent)
{
int iRC;
b4302ElemType *pElemCurr;
b4302AttrType *pAttrCurr;
int fNotText;
char *pszText;
char *szResultString; /* resulting serialized string, allocated gradually
			 in global area */
int cResultLength; /* length of result */ 
int cResultRemaining; /* remaining length of result */ 
char *pszResultFree; /* start of free zone at the end of current result */
int iIndentRemains;
int fMayIndent;

  if (pElem == NULL) { /* just to be sure... */
    return 0;
  }
  fNotText = ! (b4302NodeIsText(pElem) || 
		b4302NodeIsCDATA(pElem) ||
		b4302NodeIsComment(pElem));
  if (fNotText) { /* not a text */
    if (fCurrentMayIndent && iCurrentIndent >= 0) {
      fprintf(pDoc->fDocOut,"\n");
      b4302QuickIndent(pDoc->fDocOut,iCurrentIndent);
    }
    fprintf(pDoc->fDocOut,"<%s",pElem->pszName); /* tag name */
    /* print attributes if any: */
    pAttrCurr = pElem->pAttrFirst;
    while (pAttrCurr != NULL) {
      /* handle entitites inside value, char coding! */
      fprintf(pDoc->fDocOut," %s=\"",
	      pAttrCurr->pszName);
      if (0 != (iRC = b4302WriteAttrValue(pDoc,pAttrCurr->pszValue))) {
	fprintf(stderr,"%s: cannot convert attr value - too long?: %s\n",
		MODULE,pAttrCurr->pszValue);
      }
      fprintf(pDoc->fDocOut,"\"");
      pAttrCurr = pAttrCurr->pNext;
    } /* of printing attributes */
    if (pElem->pDown == NULL) {
      fprintf(pDoc->fDocOut,"/>"); /* empty tag */
      if (b4302NodeIsVirtualRoot(pElem->pParent)) { /***/ /* noblanks? */
	fprintf(pDoc->fDocOut,"\n"); /* just for readability (at eof) */
      }
    }
    else {
      fprintf(pDoc->fDocOut,">");
      /* check if may indent on next level: */
      if (b4302NodeIsElement(pElem)) {
	fMayIndent = (peNULL == b4302FindFirstChild(pElem,"text()"));
      }
      else {
	fMayIndent = 0;
      }
      /* if no text node on next level, we may indent! */
      pElemCurr = pElem->pDown;
      while (pElemCurr != NULL) {
	if (0 != (iRC = 
		  b4302WriteLevel(pDoc,pElemCurr,fMayIndent,
				  iCurrentIndent+pDoc->poCurr->iIndent))) { 
	  /* recursive call */
	  fprintf(stderr,"%s: cannot write %s to output file %s.\n",MODULE,
		  pElemCurr->pszName,pDoc->pszCurrentFile);
	  return 1;
	}
	pElemCurr = pElemCurr->pNext; /* next on level */
      } /* of writing out one level */
      if (fMayIndent && iCurrentIndent >= 0) { 
	/* yes this is correct
	   check fMayIndent not fCurrentMayIndent because end tag should not be
	   indented if any text node inside */
	fprintf(pDoc->fDocOut,"\n");
	b4302QuickIndent(pDoc->fDocOut,iCurrentIndent);
      }
      fprintf(pDoc->fDocOut,"</%s>",pElem->pszName); /* closing the tag */
      /* removed; with blanks, produces double blanks:
	 fprintf(pDoc->fDocOut,"\n");
      */ /* just for readability */
    } /* of nonempty tag */
  } /* of not a text node */
  else { /* text node */
    if (b4302NodeIsText(pElem)) {
      szResultString = cNULL; 
      iRC = b4302ToStringInternal(pElem,&szResultString,&cResultLength,
				  &pszResultFree,&cResultRemaining);
      if (iRC != 0) {
	ERRMSGFS(2,"%s: error serializing text %s.",(char *)(pElem->pDown));
      }
      fprintf(pDoc->fDocOut,"%s",szResultString);
      free(szResultString);
    }
    else if (b4302NodeIsComment(pElem)) {
      fprintf(pDoc->fDocOut,"<!--%s-->",(char *)pElem->pDown);
    }
    else if (b4302NodeIsCDATA(pElem)) {
      fprintf(pDoc->fDocOut,"<![CDATA[%s]]>",(char *)pElem->pDown);
    }
  }
  return 0;
} /* of b4302WriteLevel */

int b4302ParseInput(b4302DocType *pDoc)
{
  /* parses input buffers, as set in ReadFile or SetString... */
  /* returns nonzero if error in parsing */
int iRC;
b4302ElemType *pElemCurr; /* most current element; is preserved between
			     scanner calls to have elem pointer 
                             for attributes */
b4302AttrType *pAttrPrev; /* previous attribute ptr, for linking 
			     the next one */
b4302AttrType *pAttrCurr;
b4302StackItemType *psiTop;
b4302StackItemType *psiNext;
b4302StringSType *psstrCurr; /* string item (with pointer to lists of 
				attr values) for current (ie just parsed)
				attr name) */
char *szText;
int fInside; /* 1 if main doc element opened */

/* for accumulating long text strings coming from the lex scanner: */
char *pszLongString; /* the string, beginning (where allcoated) */
int cLSLength; /* current length of string */ 
int cLSRemaining; /* remaining length, to curr allocation end */ 
char *pszLSFree; /* start of free zone at the end of current result */

#define APPEND(rc,s) if (0 != (iRC = b4302AddSZ(&pszLongString,&cLSLength,\
			&pszLSFree,&cLSRemaining,s,strlen(s)))) {\
                        ERRMSGFS(rc,"%s: cannot add str %s.",s); }

  pszLongString = cNULL;

  /* make artificial ("virtual") document root, 
     with (casted) ptr to doc, and to
     two linked lists of comments and other stuff before/after the doc */
  if (0 != (iRC = b4302NewElem(&pElemCurr))) {
    ERRMSG(6,"Cannot allocate memory for virtual root element.");
  }
  pDoc->pRoot = pElemCurr;
  SET_DOC_OF_VROOT(pElemCurr,pDoc); /* cast document itself, inside macro */
  /* pParent stays NULL forever; left/next will be filled perhaps later */
  pElemCurr->pszName = ROOTPSEUDOTAGNAME; /* set it as virtual root */

  iRC = b4302NextEvent();
  while (iRC == 0) {
    /****/ /* fprintf(stderr,"token %d, len %d, <%s>\n",
                   eb4302Token,cb4302Len,pszb4302Text); /**/
    switch (eb4302Token) {
      case XXML: {
        if (cNULL == (szText = (char *) malloc(sizeof(char)*(cb4302Len+1)))) {
          fprintf(stderr,"%s: cannot allocate memory for XML string, len = %d\n",
		  MODULE,cb4302Len);
          return 18;
        }
	strcpy(szText,pszb4302Text);
        b4302StripEnd(szText);
	strcat(szText,"\n");
        pDoc->szXML = szText; /***/
	break; }
      case NOXXML: {
	szText = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
        pDoc->szXML = szText; /***/
	break; }
      case XDOCTYPE: {
        if (NULL == (szText = (char *) malloc(sizeof(char)*(cb4302Len+1)))) {
          ERRMSGFS(17,"%s: cannot allocate memory for DOC string, len = %d\n",
		   cb4302Len);
        }
	strcpy(szText,pszb4302Text);
        pDoc->szDocument = szText;
          /***/ /* remember the doctype parts! */
	break; }
      case XCOMMENT: {
        if (NULL == (szText = (char *) 
		     malloc(sizeof(char)*(strlen(b4302szComment)+1)))) {
          ERRMSGFD(28,
		   "%s: cannot allocate memory for comment string, len = %d\n",
		   cb4302Len);
        }
	strcpy(szText,b4302szComment);
	if (0 != (iRC = b4302NewElem(&pElemCurr))) {
	  ERRMSGFS(29,"%s: cannot allocate memory for comment %s",
		   b4302szComment);
	}
	pElemCurr->pszName = "/COMMENT/";
	pDoc->cElements++;
	if (fInside) { /* link element as every other node */
	  /* put it into "down" pointer, typecasted 
	     to save space for 1 pointer: */
	  pElemCurr->pDown = (b4302ElemType *) szText;
	  /* link element to the document tree: */
	  if (0 != (iRC = b4302LinkElement(pDoc,pElemCurr))) {
	    ERRMSGFS(31,"%s: cannot link comment element %s to parse stack.",
		     pElemCurr->pszName);
	  }
	  /* move down the parsing stack immediately, 
	     as if the pseudotag closes: */
	  if (0 != (iRC = b4302PopElement(pDoc))) {
	    ERRMSG(32,"cannot pop element from stack (32).");
	  }
	}
	else {
	  /* link to beg/eng of doc */

          /***/


	}
	break; 
      }
      case XTAGOPENSTART: { /* open XML tag - might still be empty */
        /* allocate memory for element: */
	if (b4302ElementNameIsInvalid(pszb4302Text) > 0) {
	  MSGFS("%s: invalid tag name: %s",pszb4302Text);
	  if (pDoc->poCurr->fParseErrorsOK == 1) {
	    pDoc->fDocumentIncompleteAfterParse = 1;
	    /* finish parsing immediately, keep doc: */
	    if (0 != (iRC = b4302FreeParsingStack(pDoc))) {
	      ERRMSGFS(25,"%s: Error freeing unused stack: %s.",
		       pDoc->pszCurrentFile);
	    } /* of freeing unused part of stack */
	    return 0;
	  }
	  else { /* error not tolerated */
	    return 26;
	  }
	} /* of name is invalid */
	fInside = 1; /* inside document for sure */
	if (0 != (iRC = b4302NewElem(&pElemCurr))) {
	  ERRMSGFS(6,"%s: cannot allocate memory for Elem %s",pszb4302Text);
	}
	pDoc->cElements++;
        /* get element string pointer (for elements, every string
	   is stored only once - ie returns same pointer): */
	if (NULL == (pElemCurr->pszName = 
		     pszb4302GetStrPtr(pDoc->sStringArea->pStrElem,
				       pszb4302Text,ADDSTRING))) {
          fprintf(stderr,"%s: cannot find/create elem name (string) %s\n",
	 	MODULE,pszb4302Text);
          return 7;
	}
	/* link element to the document tree: */
        if (0 != (iRC = b4302LinkElement(pDoc,pElemCurr))) {
          fprintf(stderr,"%s: cannot link element %s to parse stack.\n",
		  MODULE,pElemCurr->pszName);
          return 8;
	}
	pAttrPrev = NULL; /* for linking attributes */
	break;
      }  
      case XTAGCLOSESTART: { /* closing an opened XML tag */
        /* only action here: move down the parsing stack (pop) */
        if (0 != (iRC = b4302PopElement(pDoc))) {
          ERRMSG(9,"%s: cannot pop element from stack (9).");
	}
	/* check if open tag has the same name: */
	psiTop = pDoc->pParsingStack;
	if (psiTop == psiNULL ||
	    psiTop->pLastElem == peNULL /* should not even happen, but... */ 
	    ) {
	  MSGFS("%s: element close tag after end of document: </%s>",
		   pszb4302Text);
	  if (pDoc->poCurr->fParseErrorsOK == 1) {
	    pDoc->fDocumentIncompleteAfterParse = 1;
	    /* finish parsing immediately, keep doc: */
	    if (0 != (iRC = b4302FreeParsingStack(pDoc))) {
	      ERRMSGFS(22,"%s: Error freeing unused stack: %s.",
		       pDoc->pszCurrentFile);
	    } /* of freeing unused part of stack */
	    return 0;
	  }
	  else {
	    return(23);
	  }
	} /* of no element on stack (ie parsing CLOSE past doc) */
	/* now finally check the names: */
	if (strcmp(psiTop->pLastElem->pszName,pszb4302Text)) {
	  /* names differ -> open/close mismatch -> error */
	  /* PS: cannot check pointers only because pszb4302Text not
	     inserted into list of tags - makes no sense to do 
	     so for single comparison */
	  MSGFSS("%s: closing element (%s) does not match open (%s)",
		pszb4302Text,psiTop->pLastElem->pszName);
	  if (pDoc->poCurr->fParseErrorsOK == 1) {
	    pDoc->fDocumentIncompleteAfterParse = 1;
	    /* finish parsing immediately, keep doc: */
	    if (0 != (iRC = b4302FreeParsingStack(pDoc))) {
	      ERRMSGFS(23,"%s: Error freeing unused stack: %s.",
		       pDoc->pszCurrentFile);
	    } /* of freeing unused part of stack */
	    return 0;
	  }
	  else { /* error not tolerated */
	    return(24); /* signal as error */
	  }
	} /* of checking open/close element names for equality */
	/* everything ok, check if main document closed: */
	if (psiTop->pNext == psiNULL) {
	  /* yes, we have just finished parsing the document 'body' */
	  /****/ /* fprintf(stderr,"END OF DOC\n"); /**/
	  fInside = 0;
	}
	break;
      }  
      case XTAGEMPTY: { /* end of "opening" tag that had /> at the end... */ 
        /* only action here: move down the parsing stack */
        if (0 != (iRC = b4302PopElement(pDoc))) {
          fprintf(stderr,"%s: cannot pop element from stack (10).\n",
		  MODULE);
          return 10;
	}
	psiTop = pDoc->pParsingStack;
	if (psiTop == psiNULL || psiTop->pNext == psiNULL) {
	  /* yes, we have just finished parsing the document 'body' */
	  fInside = 0;
	}
	break;
      }  
      case XTAGEND: { /* do nothing here (mere '>')! */ 
	break;
      }  
      case XATTRNAME: { /* Attribute name just parsed: */ 
        iRC = b4302NewAttr(&pAttrCurr); 
        /* get attr name string pointer (for attr names, every string
	   is stored only once - ie returns same pointer): */
	pDoc->cAttrs++;
	psstrCurr = psstrb4302GetStrSPtr(pDoc->sStringArea->psslStrAttr,
				       pszb4302Text,ADDSTRING);
	if (psstrCurr == psstrNULL) {
          ERRMSGFS(8,"%s: cannot find/create attr name (string) %s\n",
		   pszb4302Text);
	}
	else {
	  pAttrCurr->pszName = psstrCurr->szString;
	}
	/* psstrCurr must survive till attr value is parsed! */
	/* link to current element: */
        pAttrCurr->pMyElem = pElemCurr;
	/* link to previous attribute or the element: */
	if (pAttrPrev == NULL) {
	  pElemCurr->pAttrFirst = pAttrCurr;
	}
	else {
	  pAttrPrev->pNext = pAttrCurr;
	}
	pAttrPrev = pAttrCurr;
	break;
      }  
      case XATTRVAL: { /*  */ 
        if (NULL == (szText = (char *) malloc(sizeof(char)*(cb4302Len+1)))) {
          ERRMSGFD(16,"%s: cannot alloc mem for attr val string, len = %d\n",
		   cb4302Len);
        }
	/* convert to internal representation, such as delete quotes, 
	   replace char refs etc. */
	/* NB!!!! Assumes conversion to internal value does not expand
	   string size -- szText allocated to scanned size only! --
	   it will not work if coding from 8 bit done inside (but it 
	   should not in fact) */
	if (0 != (iRC = b4302InternalAttrValue(szText,pszb4302Text))) {
          ERRMSGFD(19,"%s: cannot conv attr val string to int rep, len = %d\n",
		   cb4302Len);
	}
	/***/ /* code conv? */
	/* use psstrCurr from attr name parsing (see above) to 
	   speed up things: */
	if (cNULL == (pAttrPrev->pszValue = 
		      pszb4302GetStrSRefPtr(psstrCurr,
					    szText,
					    ADDSTRING))) {
	  free(szText);
	  ERRMSGFSS(33,
		   "%s: cannot add attr val (%s=)%s.",pAttrPrev->pszName,
		   pszb4302Text);
	}
	free(szText); /* only for conversion; real perm. memory allocated
			 inside pszb4302GetStrSRefPtr */
	break;
      }  
      case XTEXT: { /* text; make an element named "<" */ 
	/* create memory space for the text itself: */
        /* the following would need an extra option (do not have that...): */
        /* truncate blanks from string: */
	/*
	if (b4302StripBeg(&pszb4302Text) == 1) {
	  cb4302Len = strlen(pszb4302Text);
	}
	*/
	/***/ /* for coding from 8bit to utf-8 we might need up to 2x size! */
	if (!fInside && b4302AllBlanks(pszb4302Text)) {	
	  /* skip this! */
	}
	else if (pDoc->poCurr->fNoBlanks == 2 && 
		 b4302AllBlanks(pszb4302Text)) {
	  /* skip this! */
	}
	else if (pDoc->poCurr->fNoBlanks == 1 && 
		 b4302AllBlanks(pszb4302Text) && 0/***/) {
	  /* not impl yet: should check if any nonblank node on level... */
	  /* skip this! */
	}
	else { /* nonempty string, before conversion */

	  if (NULL == (szText = (char *) malloc(sizeof(char)*(cb4302Len+1)))) {
	    ERRMSGFD(16,"%s: cannot alloc mem for text string, len = %d\n",
		     cb4302Len);
	  }
	  if (0 != (iRC = b4302ToInternalText(szText,pszb4302Text))) {
	    free(szText);
	    ERRMSGFD(27,"%s: cannot conv text string to int rep, len = %d\n",
		     cb4302Len);
	  }
	  /***/ /* was: strcpy(szText,pszb4302Text); /**/
	  /* this would also need an option (see above) */
	  /*
	    b4302StripEnd(szText);
	  */

	  /* allocate memory for element: */
	  if (0 != (iRC = b4302NewElem(&pElemCurr))) {
	    fprintf(stderr,"%s: cannot allocate memory for text Elem %s\n",
		    MODULE,pszb4302Text);
	    return 14;
	  }
	  pDoc->cElements++;
	  pElemCurr->pszName = TEXTPSEUDOTAGNAME;
	  /* put it into "down" pointer, typecasted 
	     to save space for 1 pointer: */
	  pElemCurr->pDown = (b4302ElemType *) szText;
	  /* link element to the document tree: */
	  if (0 != (iRC = b4302LinkElement(pDoc,pElemCurr))) {
	    ERRMSGFS(12,"%s: cannot link text element %s to parse stack.",
		     pElemCurr->pszName);
	  }
	  /* move down the parsing stack immediately, 
	     as if the pseudotag closes: */
	  if (0 != (iRC = b4302PopElement(pDoc))) {
	    ERRMSG(15,"cannot pop element from stack (15).");
	  }
	}
	break;
      }
      case XCDATASTART: {
	/****/ fprintf(stderr,"XCDATASTART: %s\n",pszb4302Text); /**/
	if (pszLongString != cNULL) {
	  free(pszLongString);
	}
	pszLongString = "";
	break;
      }
      case XCDATA: {
	/****/ fprintf(stderr,"XCDATA: %s\n",pszb4302Text); /**/
	if (*pszLongString == '\0') {
	  pszLongString = cNULL;
	}
	/* append to pszLongString */
        APPEND(43,pszb4302Text);
	break;
      }
      case XCDATAEND: {
	/****/ fprintf(stderr,"XCDATAEND: %s\n",pszb4302Text); /**/
	/* allocate memory to exact length: */
	if (cNULL == (szText = (char *) malloc(sizeof(char)*
					      (strlen(pszLongString))+1))) {
	  ERRMSGFD(44,"%s: cannot alloc mem for l text string, len = %d\n",
		   strlen(pszLongString));
	}
	/* copy CDATA section to new space: */
	strcpy(szText,pszLongString);
	/* free and reinit the CDATA string memory: */
	free(pszLongString);
	pszLongString = cNULL;
	/* allocate memory for element: */
	if (0 != (iRC = b4302NewElem(&pElemCurr))) {
	  ERRMSG(45,"cannot allocate memory for CDATA Elem.");
	}
	pDoc->cElements++;
	pElemCurr->pszName = CDATAPSEUDOTAGNAME;
	/* put it into "down" pointer, typecasted 
	   to save space for 1 pointer: */
	pElemCurr->pDown = (b4302ElemType *) szText;
	/* link element to the document tree: */
	if (0 != (iRC = b4302LinkElement(pDoc,pElemCurr))) {
	  ERRMSGFS(46,"%s: cannot link text element %s to parse stack (46).",
		   pElemCurr->pszName);
	}
	/* move down the parsing stack immediately, 
	   as if the pseudotag closes: */
	if (0 != (iRC = b4302PopElement(pDoc))) {
	  ERRMSG(47,"cannot pop element from stack (47).");
	}
	/****/ fprintf(stderr,"inserted CDATA: %s\n",szText); /**/
	break;
      }
      default: {
	fprintf(stderr,"%s: token type error (from scanner).\n",MODULE);
      }  
    } /* of switch eb4302Token */

    iRC = b4302NextEvent();
  }
  if (iRC != 1) { /* except for eof: eof is ok */
    if (pDoc->poCurr->fParseErrorsOK == 1) {
      MSGFS("%s: parse error (usuallly scanning) in %s. Document kept.",
	    pDoc->pszCurrentFile);
    }
    else {
      if (0 != (iRC = b4302DestroyDoc(pDoc))) {
	MSGFS("%s: error destroying doc; memory overwrite problem? %s.",
	      pDoc->pszCurrentFile);
      }
      ERRMSGFS(999,"%s: cannot parse XML input: %s.",pDoc->pszCurrentFile);
    }
  }
  pDoc->fDocumentIncompleteAfterParse = 0; /* assume everything ok */
  if (pDoc->pParsingStack == psiNULL) {
    /* empty stack?!?! -- no data at all */
      ERRMSGFS(996,"%s: Empty input - no contents: %s.",
	       pDoc->pszCurrentFile);
  } /* of no input contents */
  if (pDoc->pParsingStack->pNext != psiNULL) {
    /* incomplete input */
    pDoc->fDocumentIncompleteAfterParse = 1;
  }
  /* free unused portion of stack in any case: */
  if (0 != (iRC = b4302FreeParsingStack(pDoc))) {
    ERRMSGFS(998,"%s: Error freeing unused stack: %s.",pDoc->pszCurrentFile);
  } /* of freeing unused part of stack */
  if (pDoc->poCurr->fParseErrorsOK == 0 &&
      pDoc->fDocumentIncompleteAfterParse == 1) {
    /* this is an error state */
    ERRMSGFS(997,"%s: Incomplete input: %s.\n",pDoc->pszCurrentFile);
  } /* of err ret: stack not completely empty, and user wants everything... */
  return 0;
#undef APPEND
} /* of b4302ParseInput */

/************************************************************************/
/* public: */

inline int b4302ElementNameIsInvalid(char *pszName)
{
  /* check element name for XML validity */
  /* this will have to change for XMl 1.1 to allow international chars */
  /* utf-8 assumed here */
  /* ... but in fact just relies on the lower chars for now */
char *pch;
  if (pszName == cNULL) {
    ERRMSG(6,"ElementNameIsInvalid: no string specified (cNULL).");
  }
  pch = pszName;
  while (*pch != '\0') {
    if (*pch == '<') {
      return 1;
    }
    else if (*pch == '>') {
      return 2;
    }
    else if (*pch == '&') {
      return 3;
    }
    else if (*pch == ';') {
      return 4;
    }
    else if (*pch == '/') {
      return 5;
    }
    /* some more? */
    pch++;
  } /* of while */
  return 0;
} /* of b4302ElementNameIsInvalid */

b4302IOOptionsType *b4302NewOptions(void)
{
b4302IOOptionsType *po;
 if ((b4302IOOptionsType *)NULL == (po = malloc(sizeof(b4302IOOptionsType)))) {
   return (b4302IOOptionsType *)NULL;
 } 
 else {
   strcpy(po->szCode,"");
   po->fParseErrorsOK = 0;
   po->fNoBlanks = 0; /* default: keep blanks as text nodes */
   po->iIndent = -1; /* default: no indentation on output */
 }
 return po;
} /* of b4302NewOptions */

void b4302SetOptionCode(b4302IOOptionsType *po, char *pszCode)
{
  if (strlen(pszCode) > 199) {
    strncpy(po->szCode,pszCode,199);
    po->szCode[199] = '\0';
    MSGFS("%s: too long code ID string: %s",pszCode);
  }
  else {
    strcpy(po->szCode,pszCode);
  }
} /* of b4302SetOptionCode */

void b4302SetOptionParseErrorsOK(b4302IOOptionsType *po, int fFlag)
{
  po->fParseErrorsOK = fFlag;
} /* of b4302SetParseErrorsOK */

void b4302SetOptionNoBlanks(b4302IOOptionsType *po, int fFlag)
{
  po->fNoBlanks = fFlag;
} /* of b4302SetOptionNoBlanks */

void b4302SetOptionIndent(b4302IOOptionsType *po, int i)
{
  po->iIndent = i;
} /* of b4302SetOptionIndent */

void b4302DeleteOptions(b4302IOOptionsType *po)
{
  free(po);
  return;
} /* of b4302DeleteOptions */


inline b4302ElemType * b4302DocGetRootElement(b4302DocType *pDoc)
{
  if (pDoc == NULL) { return NULL; }
  else {
    return pDoc->pRoot->pDown;
  }
} /* of b4302DocGetRootElement */

inline b4302ElemType * b4302GetNextElement(b4302ElemType *pElem)
{
  if (pElem == NULL) { return NULL; }
  else {
    return pElem->pNext;
  }
} /* of b4302GetNextElement */

inline b4302ElemType * b4302GetPrevElement(b4302ElemType *pElem)
{
  if (pElem == NULL) { return NULL; }
  else {
    return pElem->pLeft;
  }
} /* of b4302GetPrevElement */

inline b4302ElemType * b4302GetParent(b4302ElemType *pElem)
{
  if (pElem == NULL) { return NULL; }
  else {
    return pElem->pParent;
  }
} /* of b4302GetParent */

inline b4302ElemType * b4302GetFirstChild(b4302ElemType *pElem)
{
  if (pElem == peNULL) { return peNULL; }
  else {
    if (b4302NodeIsElement(pElem)) {
      return pElem->pDown;
    }
    else {
      return peNULL;
    }
  } /* of param not NULL */
} /* of b4302GetFirstChild */

inline b4302ElemType * b4302GetLastChild(b4302ElemType *pElem)
{
  if (pElem == peNULL ||
      !b4302NodeIsElement(pElem)) { return peNULL; }
  else {
    pElem = pElem->pDown;
    if (pElem == peNULL) {
      return peNULL; /* pElem has no children */
    }
    else {
      while (pElem->pNext != peNULL) {
	pElem = pElem->pNext;
      } /* of zooming to the end of level... */
      return pElem;
    }
  }
} /* of b4302GetLastChild */

inline b4302AttrType * b4302GetFirstAttr(b4302ElemType *pElem)
{
  if (pElem == NULL ||
      !b4302NodeIsElement(pElem)) {
    return paNULL;
  }
  else {
    return pElem->pAttrFirst;
  }
} /* of b4302FirstAttr */

inline b4302AttrType * b4302GetNextAttr(b4302AttrType *pAttr)
{
  if (pAttr == paNULL) {
    return paNULL;
  }
  else {
    return pAttr->pNext;
  }
} /* of b4302NextAttr */

b4302DocType * b4302GetDocOfElement(b4302ElemType *pElem)
{
  /* returns doc to which current element belongs. NULL on error or
     no document virtual root found */
b4302ElemType *pElemCurr;
b4302ElemType *pElemPrev;
  if (pElem == NULL) {
    ERRMSG((b4302DocType *)NULL,"Cannot get root of nonexisting element.");
  }
  pElemPrev = pElem;
  pElemCurr = pElem->pParent;
  while (pElemCurr != (b4302ElemType *)NULL) {
    /****/ /* fprintf(stderr,"elem...... %s\n",pElemCurr->pszName); /**/
    pElemPrev = pElemCurr;
    pElemCurr = pElemCurr->pParent;
  }
  if (!b4302NodeIsVirtualRoot(pElemPrev)) {
    ERRMSG(pdNULL,
	   "Virtual root does not exist. Cannot get document.");
  }
  else {
    return DOC_OF_VROOT(pElemPrev);
  }
} /* of b4302GetDocOfElement */

b4302ElemType *b4302CreateElement(b4302DocType *pd, char *pszElemName)
{
  /* creates element, gives it the name pszName, but does not link it
     to anything */
int iRC;
b4302ElemType *peCurr;

  if (pszElemName == cNULL) {
    ERRMSG(peNULL,"Cannot create element: no elem name (cNULL).");
  }
  if (0 != (iRC = b4302NewElem(&peCurr))) {
    ERRMSG(peNULL,"Cannot allocate memory for created elem.");
  }
  /* set it to name pszElemName: */
  /* get element string pointer (for elements, every string
     is stored only once - ie returns same pointer): */
  if (cNULL == (peCurr->pszName = 
		pszb4302GetStrPtr(pd->sStringArea->pStrElem,
				  (char *)pszElemName,ADDSTRING))) {
    ERRMSGFS(peNULL,"%s: cannot find/create elem (string) (createelement) %s",
	     pszElemName);
  }
  return peCurr;
} /* of b4302CreateElement */

b4302ElemType *b4302CreateNonElemNode(b4302DocType *pd, char *pszString, 
				      char *pszTypeName)
{
  /* creates element, gives it the name TEXTPSEUDOTAGNAME, and fills it
     with pszString */
  /* does not link it to anywhere */
b4302ElemType *peCurr;
char *szText;
int iRC;

  if (pd == pdNULL) {
    ERRMSG(peNULL,"Cannot create nonelem node: no document (pdNULL).");
  }
  if (pszString == cNULL) {
    ERRMSG(peNULL,"Cannot create nonelem node: no string (cNULL).");
  }
  if (pszTypeName == cNULL) {
    ERRMSG(peNULL,"Cannot create nonelem node: no type (pseudoname) (cNULL).");
  }
  if (cNULL == (szText = (char *) 
		malloc(sizeof(char)*(strlen(pszString)+1)))) {
    ERRMSGFD(peNULL,"%s: Cannot allocate memory for text string, len = %d",
	     strlen(pszString));
  }
  strcpy(szText,pszString);
  /* now create actual node: */
  if (0 != (iRC = b4302NewElem(&peCurr))) {
    ERRMSGFS(peNULL,"%s: Cannot alloc mem for nonelem node, str %s",
	     pszString);
    }
  peCurr->pszName = pszTypeName; /* mark it as text/comment/... node */
  /* put it into "down" pointer, typecasted to save space for 1 pointer: */
  peCurr->pDown = (b4302ElemType *) szText;
  return peCurr;
} /* of b4302CreateNonElemNode */

b4302ElemType *b4302CreateTextNode(b4302DocType *pd, char *pszString)
{
  /* creates element, gives it the name TEXTPSEUDOTAGNAME, and fills it
     with pszString */
  /* does not link it to anywhere */
  return b4302CreateNonElemNode(pd,pszString,TEXTPSEUDOTAGNAME);
} /* of b4302CreateTextNode */

b4302ElemType *b4302CreateCommentNode(b4302DocType *pd, char *pszString)
{
  /* creates element, gives it the name COMMENTPSEUDOTAGNAME, and fills it
     with pszString */
  /* does not link it to anywhere */
  return b4302CreateNonElemNode(pd,pszString,COMMENTPSEUDOTAGNAME);
} /* of b4302CreateCommentNode */

int b4302InsertBefore(b4302ElemType *peParent, 
		      b4302ElemType *peNew, b4302ElemType *peRef)
{
  /* insert node before Ref; ir Ref NULL, inserts as last child of Parent */
  /* can insert unbound subtree to bound or unbound subtree, or
     bound subtree to same document subtree only */
  /* NB incompatible with xmllib which inserts as first child if ref null! */

b4302DocType *pd;
b4302ElemType *peLast;
int iRC;

  if (peParent == peNULL || peNew == peNULL ||
      !b4302NodeIsElement(peParent)) {
    return 1;
  }
  /* the following is same in InsertAfter/InsertBefore - should be chgd... */
  /* check and handle fragments and such: */
  if (peNew->peParent != peNULL) {
    if (b4302NodeIsVirtualRoot(peNew->peParent)) {
      /* ok, check doc: */
      if (pdNULL == (pd = b4302GetDocOfElement(peParent))) {
	ERRMSGFS(4,"%s: No document of parent %s in insert?",
		 peParent->pszName);
      }
      if (pd != DOC_OF_VROOT(peNew->peParent)) {
	ERRMSGFS(6,"%s: Cannot insert fragment %s for different doc.",
		 peNew->pszName);
      }
      /***/ /* perhaps should temporarily bind it because of NSs? */
      if (0 != (iRC = b4302UnlinkFragment(peNew->peParent))) {
	ERRMSGFS(5,"%s: Cannot unlink fragment %s in insert?",
		 peNew->pszName);
      }
      b4302DestroyNode(peNew->peParent); /* virtual root no longer needed */
      peNew->peParent = peNULL;
    }
    else {
      ERRMSGFS(3,"%s: Cannot insert subtree (%s) which is part of another.",
	       peNew->pszName);
    }
  } /* parent not null / ie. inserting bound fragment */
  if (peRef == peNULL) { /* len peNew as last child; beware, some 
			    children can already be there */
    if (peParent->pDown != peNULL) {
      if (peNULL == (peLast = b4302GetLastChild(peParent))) {
	ERRMSG(2,"internal in InsertBefore/GetLastChild");
      }
      peLast->pNext = peNew;
      peNew->pLeft = peLast;
    }
    else { /* no children */
      peParent->pDown = peNew;
      peNew->pLeft = peNULL;
    }
    peNew->pNext = peNULL;
    peNew->pParent = peParent;
  }
  else { /* peRef defined: */
    peNew->pNext = peRef;
    peNew->pLeft = peRef->pLeft;
    peNew->pParent = peParent;
    if (peRef->pLeft != peNULL) {
      peRef->pLeft->pNext = peNew;
    }
    peRef->pLeft = peNew;
    if (peRef == peParent->pDown) { /* was first child: */
      peParent->pDown = peNew;
    }
  } /* of handling peRef defined */
  return 0;
} /* of b4302InsertBefore */

int b4302InsertAfter(b4302ElemType *peParent, 
		     b4302ElemType *peNew, b4302ElemType *peRef)
{
  /* insert node after Ref; ir Ref NULL, inserts as first child of Parent */
  /* can insert unbound subtree to bound or unbound subtree, or
     bound subtree to same document subtree only */
  /* NB incompatible with xmllib which inserts as last child if ref null! */

b4302DocType *pd;
int iRC;
  if (peParent == peNULL || peNew == peNULL ||
      !b4302NodeIsElement(peParent)) {
    return 1;
  }
  /* the following is same in InsertAfter/InsertBefore - should be chgd... */
  /* check and handle fragments and such: */
  if (peNew->peParent != peNULL) {
    if (b4302NodeIsVirtualRoot(peNew->peParent)) {
      /* ok, check doc: */
      if (pdNULL == (pd = b4302GetDocOfElement(peParent))) {
	ERRMSGFS(4,"%s: No document of parent %s in insert?",
		 peParent->pszName);
      }
      if (pd != DOC_OF_VROOT(peNew->peParent)) {
	ERRMSGFS(6,"%s: Cannot insert fragment %s for different doc.",
		 peNew->pszName);
      }
      /***/ /* perhaps should temporarily bind it because of NSs? */
      if (0 != (iRC = b4302UnlinkFragment(peNew->peParent))) {
	ERRMSGFS(5,"%s: Cannot unlink fragment %s in insert?",
		 peNew->pszName);
      }
      b4302DestroyNode(peNew->peParent); /* virtual root no longer needed */
      peNew->peParent = peNULL;
    }
    else {
      ERRMSGFS(3,"%s: Cannot insert subtree (%s) which is part of another.",
	       peNew->pszName);
    }
  } /* parent not null / ie. inserting bound fragment */
  if (peRef == peNULL) { /* peNew as the first child; beware, some 
			    children can already be there */
    if (peParent->pDown != peNULL) {
      peParent->pDown->pLeft = peNew;
    }
    peNew->pNext = peParent->pDown;
    peParent->pDown = peNew;
    peNew->pLeft = peNULL;
    peNew->pParent = peParent;
  }
  else { /* peRef defined: */
    peNew->pLeft = peRef;
    peNew->pNext = peRef->pNext;
    peNew->pParent = peParent;
    if (peRef->pNext != peNULL) {
      peRef->pNext->pLeft = peNew;
    }
    peRef->pNext = peNew;
  } /* of handling peRef defined */
  return 0;
} /* of b4302InsertAfter */

b4302ElemType *b4302RemoveChild(b4302ElemType *peParent, 
				b4302ElemType *peChildToRemove)
{
  /* removes peChildToRemove from child nodes of peParent */
  /* returns the removed node ptr (could be a subtree), or peNULL if error */
  /* does not really destroy anything; the child node lives on */
b4302ElemType *peCurrLeft;
b4302ElemType *peCurrNext;
b4302ElemType *peNewVirtualRoot;
b4302ElemType *peVR;
b4302ElemType *pePrevFirst;
b4302DocType *pd;
int iRC;

  if (peNULL == peParent ||
      peNULL == peChildToRemove ||
      !b4302NodeIsElement(peParent) ||
      peChildToRemove->pParent != peParent) {
    return peNULL;
  }
  peCurrLeft = peChildToRemove->pLeft;
  peCurrNext = peChildToRemove->pNext;
  if (peCurrLeft != NULL) {
    peCurrLeft->pNext = peCurrNext;
  }
  else {
    peParent->pDown = peCurrNext;
  }
  if (peCurrNext != NULL) {
    peCurrNext->pLeft = peCurrLeft;
  }
  peChildToRemove->pNext = peNULL;
  peChildToRemove->pLeft = peNULL;
  peChildToRemove->pParent = peNULL;

  /* create virtual root, add to fragment list: */
  if (0 != (iRC = b4302NewElem(&peVR))) {
    ERRMSG(peNULL,"Cannot allocate memory for removed elem's VR.");
  }
  /* set it as virtual root: */
  /* get element string pointer (for elements, every string
     is stored only once - ie returns same pointer): */
  peVR->pszName = ROOTPSEUDOTAGNAME; /* set it as virtual root */
  /* link to fragments: */
  if (pdNULL == (pd = b4302GetDocOfElement(peParent))) {
    ERRMSGFS(peNULL,
	      "%s: Cannot identify document when removing %s",
	      peChildToRemove->pszName);
  }
  PUSH_FRAGMENT(pd,peVR);
  peVR->peDown = peChildToRemove; /* actual root of removed tree */
  peChildToRemove->peParent = peVR; /* actual root -> virtual root ptr */

  return (peChildToRemove);
} /* of b4302RemoveChild */

b4302ElemType *b4302ReplaceChild(b4302ElemType *peParent, 
				 b4302ElemType *peNew,
				 b4302ElemType *peOld)
{
  /* replace child peOld of peParent by peNew; do not destroy old node,
     return it! */
b4302ElemType *peCurrNext;
b4302ElemType *peOldRemoved;
int iRC;

  if (peNULL == peParent ||
      peNULL == peNew ||
      peNULL == peOld ||
      !b4302NodeIsElement(peParent) ||
      peOld->pParent != peParent) {
    return peNULL;
  }
  /* remember the node *before* which the peNew should go: */
  peCurrNext = peOld->pNext;
  /* remove the old node: */
  peOldRemoved = b4302RemoveChild(peParent,peOld);

  /* insert the new one: */
  iRC = b4302InsertBefore(peParent,peNew,peCurrNext);
  /* NB: now we do not need here InsertAfter anymore because InsertBefore now
     inserts peNew as *last* child if ref (peCurrNext) == NULL */

  if (iRC != 0) {
    return peNULL;
  }
  else {
    return peOldRemoved;
  }
} /* of b4302ReplaceChild */

b4302StringSType *
b4302FreeAttrValue(b4302DocType *pd, char *pszAttrName, char *pszAttrValue)
{
  /* frees value, returns pointer to name StringS record: */
  /* returns psstrNULL if error / attr name not found */
int iHash;
b4302StringSType *psstr;
  /* search for the attr name string: */
  iHash = b4302SHASHCODE(pszAttrName);
  psstr = pd->sStringArea->psslStrAttr->psstrFirst[iHash];
  /****/ /* fprintf(stderr,"searching for %s, secondary %s, hash %d.\n",
	    pszAttrName,pszAttrValue,iHash); /**/
  while (psstr != psstrNULL) {
    /****/ /* fprintf(stderr,
	      "FreeAtrrValue: search for attr name; comparing %s.\n",
	      psstr->szString); /**/
    if (!strcmp(psstr->szString,pszAttrName)) { /* found */
      break;
    }
    psstr = psstr->psstrNext;
  }
  if (psstr == psstrNULL) { /* primary string not found, error -> exit */
    return psstrNULL;
  }
  if (cNULL == pszb4302GetStrSRefPtr(psstr,pszAttrValue,SEARCHONLY)) {
    /* string not found in stored list of values -> 
       deallocate from global area: */
    /****/ /* fprintf(stderr,"FREEING GLOBAL AREA... str (%s=)%s.\n",
		   pszAttrName,pszAttrValue); /**/
    free(pszAttrValue);
  }
  /* else found: do nothing (mem freed only when doc destroyed) */
    /****/ /* fprintf(stderr,"not freeing list item: str (%s=)%s.\n",
		   pszAttrName,pszAttrValue); /**/
  return psstr; /* not NULL here */
} /* of b4302FreeAttrValue */

b4302AttrType * b4302GetAttributeNode(b4302ElemType *pElem, 
				    const char *pszAttrName)
{
b4302AttrType *pAttrCurr;
  /* get attribute value of element by attr name, NULL if not found */
  if (pElem == peNULL || pszAttrName == cNULL) {
    ERRMSG(paNULL,"GetAttributeNode: no node and/or no attr name.");
  }
  pAttrCurr = b4302GetFirstAttr(pElem);
  while (pAttrCurr != paNULL) {
    if (!strcmp(pAttrCurr->pszName,pszAttrName)) { /* found */ /***/ /* ns */
      return pAttrCurr;
    }
    pAttrCurr = b4302GetNextAttr(pAttrCurr);
  } /* of going through attributes of element */
  return paNULL; /* not found if got here */
} /* of b4302GetAttributeNode */

inline char * b4302GetAttribute(b4302ElemType *pElem, const char *pszAttrName)
{
b4302AttrType *pAttrCurr;
  /* get attribute value of element by attr name, NULL if not found */
  if (pElem == peNULL || pszAttrName == cNULL) {
    ERRMSG(cNULL,"GetAttribute cannot work for no node and/or no attr name.");
  }
  if (paNULL == (pAttrCurr = b4302GetAttributeNode(pElem,pszAttrName))) {
    return cNULL; /* not found */
  }
  else {
    return pAttrCurr->pszValue;
  }
} /* of b4302GetAttribute */

inline b4302AttrType * b4302DocSetAttribute(b4302DocType *pd,
					    b4302ElemType *pElem, 
					    const char *pszAttrName, 
					    const char *pszAttrValue)
{
b4302AttrType *pAttrCurr;
int iRC;
b4302StringSType *psstrAttr;
  /* set attribute value of element by attr name, NULL if not found */
  if (pElem == NULL || pszAttrName == NULL || pszAttrValue == NULL ||
      !b4302NodeIsElement(pElem)) {
    ERRMSG(paNULL,
           "SetAttribute cannot work for bad node/no attr name/value.");
  }
  /* check if attribute at current elem already set: */
  pAttrCurr = b4302GetFirstAttr(pElem);
  while (pAttrCurr != paNULL) {
    if (!strcmp(pAttrCurr->pszName,pszAttrName)) { /* found */ /***/ /* ns */
      if (pAttrCurr->pszValue == cNULL) {
	/* this should not happen... */
	ERRMSGFS((b4302AttrType *)NULL,
	       "%s: pszValue is NULL of attr %s ?!?!",pAttrCurr->pszName);
      }
      /* free value (if in global area): */
      psstrAttr = b4302FreeAttrValue(pd,
				     pAttrCurr->pszName,pAttrCurr->pszValue);
      /* add new one (either to string list if short enough 
	 or to global area: */
      if (cNULL == (pAttrCurr->pszValue = 
		    pszb4302GetStrSRefPtr(psstrAttr,
					  (char *) pszAttrValue,
					  ADDSTRING))) {
	ERRMSGFS(paNULL,
		 "%s: cannot add attr val %s.",pszAttrValue);
      }
      return pAttrCurr; 
    }
    pAttrCurr = pAttrCurr->paNext;
  } /* of going through attributes of element */

  /* not found: add attribute at beg of chain: */
  iRC = b4302NewAttr(&pAttrCurr); 
  /* get document ptr of elment; needed for string handling */
  pd->cAttrs++;
  /* get attr name string pointer (for attr names, every string
     is stored only once - ie returns same pointer): */

  if (psstrNULL == (psstrAttr = 
		    psstrb4302GetStrSPtr(pd->sStringArea->psslStrAttr,
					 (char *) pszAttrName,ADDSTRING))) {
    ERRMSGFS(paNULL,
	     "%s: cannot find/create attr name (string) %s\n",
	     pszAttrName);
  }
  pAttrCurr->pszName = psstrAttr->szString;
  /* store value: */
  /* add new one (either to string list if short enough 
     or to global area: */
  if (cNULL == (pAttrCurr->pszValue = 
		pszb4302GetStrSRefPtr(psstrAttr,
				      (char *) pszAttrValue,
				      ADDSTRING))) {
    ERRMSGFS(paNULL,
	     "%s: cannot add attr val %s.",pszAttrValue);
  }
  /* uplink to current element: */
  pAttrCurr->pMyElem = pElem;
  /* link to the element: */
  pAttrCurr->pNext = pElem->pAttrFirst;
  pElem->pAttrFirst = pAttrCurr;
  return pAttrCurr; /* return new attrib record */
} /* of b4302DocSetAttribute */

inline b4302AttrType * b4302SetAttribute(b4302ElemType *pElem, 
					 const char *pszAttrName, 
					 const char *pszAttrValue)
{
b4302DocType *pd;
  if (pdNULL == (pd = b4302GetDocOfElement(pElem))) {
    ERRMSGFSS(paNULL,
	      "%s: Cannot identify document when adding %s = %s",
	      pszAttrName,pszAttrValue);
  }
  return (b4302DocSetAttribute(pd,pElem,pszAttrName,pszAttrValue));
} /* of b4302SetAttribute */

int b4302DocRemoveAttribute(b4302DocType *pd,
			    b4302ElemType *pElem, 
			    const char *pszAttrName) 
{
b4302AttrType *pAttrCurr;
b4302AttrType *pAttrPrev;
char *szText;
int iRC;

  /* remove attribute of element by attr name, return NULL if not found */
  if (pd == pdNULL || pElem == peNULL || pszAttrName == cNULL) {
    ERRMSG(1,
           "RemoveAttribute cannot work for no node/no attr name/value.");
  }
  pAttrPrev = paNULL;
  pAttrCurr = b4302GetFirstAttr(pElem);
  while (pAttrCurr != paNULL) {
    if (!strcmp(pAttrCurr->pszName,(char *)pszAttrName)) { 
      /* found */ /***/ /* ns */
      /* unlink attrib, destroy: */
      if (pAttrPrev == paNULL) {
	pElem->pAttrFirst = pAttrCurr->pNext;
      }
      else {
	pAttrPrev->pNext = pAttrCurr->pNext;
      }

      /* was: free(pAttrCurr->pszValue); */
      b4302FreeAttrValue(pd,pAttrCurr->pszName,pAttrCurr->pszValue);
      free(pAttrCurr);
      pd->cAttrs--;
      return 0;
    }
    pAttrPrev = pAttrCurr;
    pAttrCurr = b4302GetNextAttr(pAttrCurr);
  } /* of going through attributes of element */
  /* not found */
  return -1;
} /* of b4302DocRemoveAttribute */

int b4302RemoveAttribute(b4302ElemType *pElem, 
			 const char *pszAttrName) 
{
b4302DocType *pd;
  if (pdNULL == (pd = b4302GetDocOfElement(pElem))) {
    ERRMSGFS(1,
	     "%s: Cannot identify document when removing attr %s",
	     pszAttrName);
  }
  return (b4302DocRemoveAttribute(pd,pElem,pszAttrName));

} /* of b4302RemoveAttribute */

char *b4302GetData(b4302ElemType *pElem)
{
  /* get text contents (empty for true elements, NULL for error) */
  if (pElem == peNULL) {
    return cNULL;
  }
  else {
    if (b4302NodeIsText(pElem)) {
      return (char *) (pElem->pDown);
    }
    if (b4302NodeIsComment(pElem)) {
      return (char *) (pElem->pDown);
    }
    if (b4302NodeIsCDATA(pElem)) {
      return (char *) (pElem->pDown);
    }
    else {
      return "";
    }
  }
} /* of b4302GetData */

char *b4302SetData(b4302ElemType *pElem, const char *pszString)
{
char *szText;

  /* set (replace) text contents (only for text-based elementes) */
  /* do nothing for other */
  /* return pointer to new mem area with a *copy* of input string,
     NULL for error of not correct node type */
  if (pElem == NULL) {
    return cNULL;
  }
  else {
    if (b4302NodeIsText(pElem)) { /* ok */
      if (pElem->pDown != peNULL) {
        free(pElem->pDown); /* text elements always allocated in global area */
      }
      if (cNULL == (szText = (char *) 
	       malloc(sizeof(char)*(strlen(pszString)+1)))) {
	ERRMSGFD(cNULL,
		 "%s: Cannot allocate memory for text string, len = %d",
		 strlen(pszString));
      }
      pElem->pDown = (b4302ElemType *) szText;
      strcpy(szText,pszString);
      return (char *) (pElem->pDown);
    }
    if (b4302NodeIsComment(pElem)) { /* ok */
      if (pElem->pDown != peNULL) {
        free(pElem->pDown); /* text elements always allocated in global area */
      }
      if (cNULL == (szText = (char *) 
	       malloc(sizeof(char)*(strlen(pszString)+1)))) {
	ERRMSGFD(cNULL,
		 "%s: Cannot allocate memory for text string, len = %d",
		 strlen(pszString));
      }
      pElem->pDown = (b4302ElemType *) szText;
      strcpy(szText,pszString);
      return (char *) (pElem->pDown);
    }
    if (b4302NodeIsCDATA(pElem)) { /* ok */
      if (pElem->pDown != peNULL) {
        free(pElem->pDown); /* text elements always allocated in global area */
      }
      if (cNULL == (szText = (char *) 
	       malloc(sizeof(char)*(strlen(pszString)+1)))) {
	ERRMSGFD(cNULL,
		 "%s: Cannot allocate memory for CDATA string, len = %d",
		 strlen(pszString));
      }
      pElem->pDown = (b4302ElemType *) szText;
      strcpy(szText,pszString);
      return (char *) (pElem->pDown);
    }
    else { /* not a text-based node */
      return cNULL;
    }
  }
} /* of b4302SetData */

b4302ElemType *b4302DocAppendText(b4302DocType *pd,
				  b4302ElemType *peParent, 
				  const char *pszString)
{
b4302ElemType *peLastChild;
b4302ElemType *peCurr;
char *szText;
int iRC;

  /* add pszString as last child node of peParent;
     if last child of peParent is a text node, concat both
     into a single node */
  /* return ptr to text node created/concat-to, NULL on error */
  if (pd == pdNULL) {
    ERRMSG(peNULL,"Cannot append text child: no document (pdNULL).");
  }
  if (pszString == cNULL) {
    ERRMSG(peNULL,"Cannot append text: no string (cNULL).");
  }
  if (peParent == NULL) {
    ERRMSGFS(peNULL,"%s: cannot append text %s to nonexistent node.",
	     pszString);
  }
  /* get current last child: */
  peLastChild = b4302GetLastChild(peParent);
  if (peLastChild == peNULL ||
      (!b4302NodeIsText(peLastChild) &&
       !b4302NodeIsComment(peLastChild))) { /* no child at all, or last
					  child is not text node */
    /* ... create a completely new elem (text) node: */
    if (peNULL == (peCurr = b4302CreateTextNode(pd,(char *)pszString))) {
      ERRMSGFD(peNULL,"%s: Cannot allocate memory for text string, len = %d",
	       strlen(pszString));
    }
    /* link element to the document tree: */
    peCurr->pParent = peParent; /* uplink to parent */
    if (peLastChild == NULL) { /* no children yet, link as first node */
      peParent->pDown = peCurr;
    }
    else {
      peCurr->pLeft = peLastChild;
      peLastChild->pNext = peCurr;
    }
    return peCurr;
  }
  else { /* last child exists *and* is a text/comment node: concat */
    if (cNULL == (szText = 
		  b4302AllocString2((char *)(peLastChild->pDown),
				    (char *)pszString))) {
      ERRMSGFSS(peNULL,"%s: Cannot alloc mem for concat text, str %s%s",
	       (char *)(peLastChild->pDown),pszString);
    }
    free(peLastChild->pDown);
    peLastChild->pDown = (b4302ElemType *) szText;
    return peLastChild;
  }
} /* of b4302DocAppendText */

b4302ElemType *b4302AppendText(b4302ElemType *peParent, 
			       const char *pszString)
{
b4302DocType *pd;
  if (pdNULL == (pd = b4302GetDocOfElement(peParent))) {
    ERRMSGFS(peNULL,
	     "%s: Cannot identify document when appending %s",
	     pszString);
  }
  return (b4302DocAppendText(pd,peParent,pszString));
} /* of b4302AppendText */

b4302ElemType *b4302DocAppendTextChild(b4302DocType *pd, 
				       b4302ElemType *peParent, 
				       const char *pszElemName,
				       const char *pszString)
{
  /* append as last element of peParent a new node (create it)
     with name pszElemName, no attrs, and contents set to a new 
     text node (create it to) containing pszString */
b4302ElemType *peCurr;
b4302ElemType *peText;
b4302ElemType *peLastChild;
int iRC;

  if (pd == pdNULL) {
    ERRMSG(peNULL,"Cannot append text child: no document (pdNULL).");
  }
  if (pszString == cNULL) {
    ERRMSG(peNULL,"Cannot append text child: no string (cNULL).");
  }
  if (pszElemName == cNULL) {
    ERRMSG(peNULL,"Cannot append text child: no elem name (cNULL).");
  }
  if (peParent == NULL) {
    ERRMSGFSS(peNULL,"%s: cannot append <%s>%s to nonex node (app..child).",
	     pszElemName,pszString);
  }
  /* create the new element: */
  if (peNULL == (peCurr = b4302CreateElement(pd, (char *)pszElemName))) {
    ERRMSGFS(peNULL,"%s: cannot create elem, name %s.",pszElemName);
  }
  /* link element to the document tree: */
  peCurr->pParent = peParent; /* uplink to parent */
  peLastChild = b4302GetLastChild(peParent);
  if (peLastChild == NULL) { /* no children yet, link as first node */
    peParent->pDown = peCurr;
  }
  else {
    peCurr->pLeft = peLastChild;
    peLastChild->pNext = peCurr;
  }
  /* now create and append the text itself: */
  if (peNULL == (peText = b4302DocAppendText(pd,peCurr,pszString))) {
    ERRMSGFS(peNULL,"%s: cannot create text (string) (app..child) %s",
	   pszString);
  }
  return peCurr;  
} /* of b4302DocAppendTextChild */

b4302ElemType *b4302AppendTextChild(b4302ElemType *peParent, 
				    const char *pszElemName,
				    const char *pszString)
{
  /* append as last element of peParent a new node (create it)
     with name pszElemName, no attrs, and contents set to a new 
     text node (create it to) containing pszString */
b4302DocType *pd;
  if (pdNULL == (pd = b4302GetDocOfElement(peParent))) {
    ERRMSGFSS(peNULL,
	      "%s: Cannot identify document when appending <%s>%s",
	      pszElemName,pszString);
  }
  return (b4302DocAppendTextChild(pd,peParent,pszElemName,pszString));
} /* of b4302AppendTextChild */

int b4302DestroyNode(b4302ElemType *peNode)
{
b4302AttrType *pa;
b4302AttrType *paNext;
b4302DocType *pd;

  if (peNode == peNULL) { /* nothing to do */
    return 0;
  }
  if (b4302NodeIsVirtualRoot(peNode)) { /* do nothing! should 
						not touch pAttrFirst 
						(cast to document!) */
  }
  else if (b4302NodeIsText(peNode) || b4302NodeIsComment(peNode)) {
    /****/ /* fprintf(stderr,
	      "freeing text elem: %s\n",(char *)peNode->pDown); /**/
    free(peNode->pDown); /* in fact, it is a char * pointer, 
			    globally allocated */
    /* has no attrs */
  }
  else {
    /* free attributes first: */
    pa = peNode->pAttrFirst;
    pd = pdNULL;
    if (pa != paNULL) {
      if (pdNULL == (pd = b4302GetDocOfElement(peNode))) {
	ERRMSGFS(1,"%s: No document of node %s in DestroyNode?",
		 peNode->pszName);
      }
    } /* some attribute: need to find doc of element node */
    while (pa != paNULL) {
      paNext = pa->pNext;
      b4302FreeAttrValue(pd,pa->pszName,pa->pszValue);
      /* do not free pszName, it is in string area and possibly shared! */
      free(pa);
      pa = paNext;
    }
  }
  /* free the node: */
  /* do not free elem's pszName, it is in string area and possibly shared! */
  free(peNode);
  return 0;
} /* of b4302DestroyNode */

int b4302DestroySubtree(b4302ElemType *peSub)
{
  /* destroy (free mem) for the whole subtree */
  /* postfix traversal */
  /* !! virtual root cannot be used for call to DestroySubtree */
b4302ElemType *peCurr;
b4302ElemType *peNext;
int iRC;

  if (peSub == peNULL) { /* nothing to do */
    return 0;
  }
  if (b4302NodeIsElement(peSub)) {  /* only elements (and virtual root)
				       have children; 
				       pDown used for storing the 
				       text/comment/... in fact! */
    /* virtual root cannot be used for call to DestroySubtree */
    peCurr = peSub->pDown;
    while (peCurr != peNULL) {
      peNext = peCurr->pNext;
      if (0 != (iRC = b4302DestroySubtree(peCurr))) {
	return 1;
      }
      peCurr = peNext;
    }
  } /* of node not text */
  if (0 != (iRC = b4302DestroyNode(peSub))) {
    return 2;
  }
  return 0;
} /* of b4302DestroySubtree */

void b4302FreeStrList(b4302StringListType *psl)
{
b4302StringType *pstr;
b4302StringType *pstrNext;
int i;
  if (psl == pslNULL) {
    return;
  }
  for (i = 0; i < b4302HASHMAX; i++) {
    pstr = psl->pFirst[i];
    while (pstr != pstrNULL) {
      pstrNext = pstr->pNext;
      /****/ /* fprintf(stderr,"freeing global str %s\n",pstr->szString); /**/
      free(pstr->szString);
      free(pstr);
      pstr = pstrNext;
    }
  }
  free(psl);
  return;
} /* of b4302FreeStrList */

void b4302FreeStrSList(b4302StringSListType *pssl)
{
b4302StringType *pstr;
b4302StringSType *psstr;
b4302StringType *pstrNext;
b4302StringSType *psstrNext;
int i;

  if (pssl == psslNULL) {
    return;
  }
  for (i = 0; i < b4302SHASHMAX; i++) {
    psstr = pssl->psstrFirst[i];
    while (psstr != psstrNULL) {
      psstrNext = psstr->psstrNext;
      b4302FreeStrList(psstr->pslSecondary);
      /****/ /* fprintf(stderr,"freeing attr %s\n",psstr->szString); /**/
      free(psstr->szString);
      free(psstr);
      psstr = psstrNext;
    }
  }
  free(pssl);
  return;
} /* of b4302FreeStrSList */

int b4302DestroyDoc(b4302DocType *pd)
{
int iRC;
b4302StringAreaType *psa;
b4302ElemType *peFragmentVR; /* current fragment virt root */
b4302ElemType *peFragmentVRNext; /* next fragment virt root */

  if (pd == pdNULL) { return 0; }
  /* free unused portion of stack: */
  while (pd->pParsingStack != psiNULL) {
    if (0 != (iRC = b4302PopElement(pd))) {
      ERRMSGFS(3,"%s: Error freeing unused stack: %s.",pd->pszCurrentFile);
    }
  } /* of while: freeing unused part of stack */
  /* destroy all fragments bound to this docuemnt: */
  peFragmentVR = pd->peFirstFragment;
  while (peFragmentVR != peNULL) {
    /* destroy the fragment: */
    peFragmentVRNext = peFragmentVR->pNext; /* next fragment linked by 
					       pNext of virtual root */
    if (0 != (iRC = b4302DestroySubtree(peFragmentVR->pDown))) {
      ERRMSG(3,"Error destroying subtree for doc fragment.");
    }
    if (0 != (iRC = b4302DestroyNode(peFragmentVR))) {
      ERRMSG(4,"Error destroying virt root node of fragment.");
    }
    peFragmentVR = peFragmentVRNext; /* next fragment */
  }
  /* destroy document itself: */
  if (0 != (iRC = b4302DestroySubtree(b4302DocGetRootElement(pd)))) {
    ERRMSG(1,"Error destroying subtree for doc.");
  }
  if (0 != (iRC = b4302DestroyNode(pd->pRoot))) {
    ERRMSG(2,"Error destroying virt root node.");
  }
  /* free all string areas: */
  psa = pd->sStringArea;
  b4302FreeStrList(psa->pStrElem);
  b4302FreeStrSList(psa->psslStrAttr);
  free(psa);
  free(pd->poCurr);
  free(pd);
  return 0;
} /* of b4302DestroyDoc */

b4302ElemType *b4302FindInternal(b4302ElemType *peNode, char *pszSearchString, 
				 int iType)
{
  /* finds first node in direction specified by iType */
  /* nonrecursive */
  /* returns peNULL if not found or error, otherwise node pointer */
b4302ElemType *peCurr;
typedef enum { STUNK, STELEM, STELEMVAL, STANY, STTEXT, STATTR, STATTRVAL,
	       STCOMMENT, STPROC, STNODE } eSearchType;
eSearchType iSearchType;
char *szSearchName;
char *szSearchValue;
int fAllocatedANV;
char *pchIn;
int cNameChars;
char *pszVal;
int iRC;
b4302AttrType *paCurr;
char *pszData;

#define FREEANV { if (fAllocatedANV == 1) { free(szSearchName); free(szSearchValue); } }
#define FREESOE { if (pszData != cNULL && *pszData != '\0') { free(pszData); }}

  if (peNode == peNULL) {
    return peNULL;
  }

  /****/ /* fprintf(stderr,"searching at %s for..... %s\n",
		 peNode->pszName,pszSearchString); /**/
  fAllocatedANV = 0;
  /* determine search type: */
  iSearchType = STUNK;
  if (!strcmp(pszSearchString,"*")) {
    iSearchType = STANY;
  }
  else if (!strcmp(pszSearchString,"text()")) {
    iSearchType = STTEXT;
  }
  else if (!strcmp(pszSearchString,"comment()")) {
    iSearchType = STCOMMENT;
  }
  else if (!strcmp(pszSearchString,"processing-instruction()")) {
    iSearchType = STPROC;
  }
  else if (!strcmp(pszSearchString,"node()")) {
    iSearchType = STNODE;
  }
  else if (*pszSearchString == '@') {
    iSearchType = STATTR;
    /* check if perhaps value specified, too: */
    if (cNULL != (pszVal = strchr((const char *)pszSearchString,'='))) {
      /* equal char found... extract name and value: */
      if (cNULL == (szSearchName = (char *) 
		    malloc(sizeof(char)*(strlen(pszSearchString)+2)))) {
	ERRMSGFS(peNULL,"%s: cannot allocate mem for attr name in find: %s",
		 pszSearchString);
      }
      if (cNULL == (szSearchValue = (char *) 
		    malloc(sizeof(char)*(strlen(pszSearchString)+1)))) {
	free(szSearchName);
	ERRMSGFS(peNULL,"%s: cannot allocate mem for attr val in find: %s",
		 pszSearchString);
      }
      fAllocatedANV = 1;
      strcpy(szSearchName,pszSearchString+1); /* ignore @ */
      if (cNULL != (pszVal = strchr((const char *)szSearchName,'='))) {
	*pszVal++ = '\0'; /* now szSearchName really contains name only */
	/* pszVal points to start of quote (hopefully...) for value: */
        if (0 != (iRC = b4302InternalAttrValue(szSearchValue,pszVal))) {
	  FREEANV;
	  ERRMSGFS(peNULL,"%s: wrong attr value: %s",pszSearchString);
	}
	/* else value now in szSearchValue */
      }
      else { /* equal sign not found !?!! (already found once...) */
	FREEANV;
	ERRMSGFS(peNULL,"%s: cannot find = sign!?!? in: %s",
		 pszSearchString);
      }
      /****/ /* fprintf(stderr,
		"name %s, val %s\n",szSearchName,szSearchValue); /**/
    }
    else { /* attr name only */
      szSearchName = pszSearchString + 1;
      szSearchValue = cNULL;
    }
  }
  else if (!strcmp(pszSearchString,"")) {
    ERRMSG(peNULL,"Cannot search for zero length element name.");
  }
  else { /* nonzero string, no special value, not an attr (@): */
    /* check if perhaps value specified, too: */
    if (cNULL != (pszVal = strchr((const char *)pszSearchString,'='))) {
      /* equal char found... extract name and value: */
      if (cNULL == (szSearchName = (char *) 
		    malloc(sizeof(char)*(strlen(pszSearchString)+2)))) {
	ERRMSGFS(peNULL,"%s: cannot allocate mem for elem name in find: %s",
		 pszSearchString);
      }
      if (cNULL == (szSearchValue = (char *) 
		    malloc(sizeof(char)*(strlen(pszSearchString)+1)))) {
	free(szSearchName);
	ERRMSGFS(peNULL,"%s: cannot allocate mem for elem val in find: %s",
		 pszSearchString);
      }
      fAllocatedANV = 1;
      strcpy(szSearchName,pszSearchString);
      if (cNULL != (pszVal = strchr((const char *)szSearchName,'='))) {
	*pszVal++ = '\0'; /* now szSearchName really contains name only */
	if (*pszVal == '\"' || *pszVal == '\'') { /* allow for no quote! */
	  pszVal++; 
	  if (pszVal[strlen(pszVal)-1] == '\"' ||
	      pszVal[strlen(pszVal)-1] == '\'') { /* delete final quote */
	    pszVal[strlen(pszVal)-1] = '\0';
	  }
 	} /* of value is quoted */
	/* pszVal points to after a quote (hopefully...) for value: */
        if (0 != (iRC = b4302ToInternalText(szSearchValue,pszVal))) {
	  FREEANV;
	  ERRMSGFS(peNULL,"%s: wrong elem text value: %s",pszSearchString);
	}
	/* else value now in szSearchValue */
      }
      else { /* equal sign not found !?!! (already found once...) */
	FREEANV;
	ERRMSGFS(peNULL,"%s: cannot find = sign (text search str)!?!? in: %s",
		 pszSearchString);
      }
      /****/ /* fprintf(stderr,
		"name %s, val %s\n",szSearchName,szSearchValue); /**/
      iSearchType = STELEMVAL;
    }
    else { /* attr name only */
      szSearchName = pszSearchString;
      szSearchValue = cNULL;
      iSearchType = STELEM;
    }

  } /* of last else branch: no spec type, element with value (possibly) */
  /***/ /* temp: */
  if (iSearchType == STPROC || 
      iSearchType == STUNK || 
      iSearchType == STNODE) {
    FREEANV;
    ERRMSGFS(peNULL,"%s: search for %s no yet implemented.",pszSearchString);
  }

  /* select node to start at: */
  switch (iType) {
  case 1: { /* Child */
    if (b4302NodeIsElement(peNode)) {
      peCurr = peNode->pDown; 
      /* virt root allowed, even though makes little sense */
    }
    else {
      FREEANV;
      ERRMSGFS(peNULL,
	       "%s: Node is not reg. element - cannot search children for %s.",
	       pszSearchString);
    }
    break;
  }
  case 2: { /* NextSibling */
    peCurr = peNode->peNext; /* all types allowed */
    break;
  }
  case 3: { /* PrevSibling */
    peCurr = peNode->peLeft; /* all types allowed */
    break;
  }
  case 4: { /* Ancestor */
    if (b4302NodeIsVirtualRoot(peNode)) {
      FREEANV;
      ERRMSGFS(peNULL,"%s: Cannot search ancestors of virt root for %s.",
	       pszSearchString);
    }
    else {
      peCurr = peNode->peParent;
    }
    break;
  }
  default: {
    FREEANV;
    ERRMSGFD(peNULL,"%s: Internal - wrong type in FindInternal: %d",iType);
  }
  } /* of start node determination switch */

  /* main loop: */
  while (peCurr != peNULL) {
    switch (iSearchType) { /* behave according to search string parameter: */
    case STELEM: {
      if (b4302NodeIsElement(peCurr)) {
	if (!strcmp(peCurr->pszName,pszSearchString)) { /* found */
	  return peCurr;
	} /* of element found */
      } /* of node is element */
      break;
    }
    case STELEMVAL: {
      if (b4302NodeIsElement(peCurr)) { /* must be element */
	if (!strcmp(peCurr->pszName,szSearchName)) { /* found by name */
	  /* must check text value: */
	  pszData = b4302StringOfElement(peCurr);
	  /****/ /* fprintf(stderr,"text value of node: %s\n",pszData); /**/
	  if (!strcmp(szSearchValue,pszData)) {
	    /* found! */
	    FREESOE;
	    return peCurr;
	  }
	  FREESOE;
	} /* of element found */
      } /* current node is element */
    } /* of STELEMVAL */
    case STTEXT: {
      if (b4302NodeIsText(peCurr)) { /* return first text node found */
	return peCurr;
      }
      break;
    }
    case STANY: {
      if (b4302NodeIsElement(peCurr)) { /* return first element found */
	return peCurr;
      }
      break;
    }
    case STATTR: {
      if (b4302NodeIsElement(peCurr)) { /* must be element */
	if (paNULL != (paCurr = b4302GetAttributeNode(peCurr,szSearchName))) {
	  /* attribute name found! */
	  if (szSearchValue == cNULL) { /* value equality not req'd */
	    FREEANV;
	    return peCurr;
	  }
	  else { /* must check value, too */
	    if (!strcmp(szSearchValue,paCurr->pszValue)) { /* value found, too */
	      FREEANV;
	      return peCurr;
	    }
	  } /* of else... must check value of attr */
	} /* of if attr name found in peCurr */
      } /* current node is element */
    } /* of STATTR */
    case STCOMMENT: {
      if (b4302NodeIsComment(peCurr)) {
	return peCurr;
      }
      break;
    }
    case STPROC:
    case STNODE:
    default: {
      break;
    }
    } /* of switch - search type -> test current node if it matches */

    /* select continuation of search in main loop: */
    switch (iType) {
    case 1:
    case 2: { /* Child and NextSibling goes right */
      peCurr = peCurr->peNext;
      break;
    }
    case 3: { /* PrevSibling */
      peCurr = peCurr->peLeft;
      break;
    }
    case 4: { /* Ancestor */
      peCurr = peCurr->peParent;
      break;
    }
    } /* of continuation switch */
  } /* of while - main loop */
  FREEANV;
  return peNULL;
} /* of b4302FindInternal */

b4302ElemType *b4302FindFirstChild(b4302ElemType *peParent, char *pszStr)
{
  /* finds first child element of peParent based on pszStr */
  /* nonrecursive */
  /* returns peNULL if not found or error, otherwise element pointer */
  return b4302FindInternal(peParent,pszStr,1); /* type 1 */
} /* of b4302FindFirstChild */

b4302ElemType *b4302FindNextSibling(b4302ElemType *peNode, char *pszStr)
{
  /* finds first node to the right of peNode based on string pszStr */
  /* nonrecursive */
  /* returns peNULL if not found or error, otherwise element pointer */
  return b4302FindInternal(peNode,pszStr,2); /* type 2, next sibling */
} /* of b4302FindNextSibling */

b4302ElemType *b4302FindPrevSibling(b4302ElemType *peNode, char *pszStr)
{
  /* finds first node to the left of peNode based on string pszStr */
  /* nonrecursive */
  /* returns peNULL if not found or error, otherwise element pointer */
  return b4302FindInternal(peNode,pszStr,3); /* type 3, prev sibling */
} /* of b4302FindPrevSibling */

b4302ElemType *b4302FindAncestor(b4302ElemType *peChild, char *pszStr)
{
  /* finds first node on parent path of peChild based on pszStr */
  /* nonrecursive */
  /* returns peNULL if not found or error, otherwise element pointer */
  return b4302FindInternal(peChild,pszStr,4); /* type 4 */
} /* of b4302FindAncestor */

int b4302ReadFile(b4302DocType **ppDoc, char *pszFileName,
		  b4302IOOptionsType *po)
{
int iRC;
b4302DocType *pDoc;

  *ppDoc = NULL; /* in ReadFile, always allocate new Doc; caller
                     should make sure there is no memory leak! */
  if (0 != (iRC = b4302AllocateDoc(ppDoc))) {
    ERRMSG(1,"cannot allocate document record in ReadFile.");
  }
  pDoc = *ppDoc;

  if (0 != (iRC = b4302OpenFile(pDoc,pszFileName,"rt"))) {
    fprintf(stderr,"%s: cannot open input file in ReadFile: %s.\n",
	    MODULE,pszFileName);
    /***/ /* free pDoc here! */
    return 2;
  }

  yyin = pDoc->fDocIn; /* flex's input file */

  memcpy(pDoc->poCurr,po,sizeof(b4302IOOptionsType)); /* set options */

  b4302fParsing = 1; /* now cannot open another file/string for reading */

  BEGIN(INITIAL); /* reset scanner state */
  iRC = b4302ParseInput(pDoc);

  fclose(pDoc->fDocIn);
  pDoc->fDocIn = NULL;

  b4302fParsing = 0; /* can open another file/set string */
  if (iRC == 0) {
    *ppDoc = pDoc;
  }
  else {
    *ppDoc = NULL;
  }
  return iRC;
} /* of b4302ReadFile */

int b4302WriteFile(b4302DocType *pDoc, char *pszFileName)
{
int iRC;
b4302ElemType *pElemCurr;
b4302AttrType *pAttrCurr;
char *szBuffer; /* allocated only for efficiency */

char *szText;

  if (pszFileName == cNULL) {
    ERRMSG(7,"Cannot write to empty filename (cNULL).");
  }
  if (pDoc == pdNULL || pDoc->pRoot == peNULL) {
    ERRMSGFS(6,"%s: cannot write nonalloc document (or doc w/no root) to %s.",
	     pszFileName);
  }
  if (0 != (iRC = b4302OpenFile(pDoc,pszFileName,"wt"))) {
    ERRMSGFS(1,"%s: cannot open input file in b4302WriteFile: %s.",
	     pszFileName);
  }
  if (cNULL == (szBuffer = (char *) malloc(131072*sizeof(char)))) {
    ERRMSGFS(4,"%s: cannot allocate buffer for output file %s.",
	     pszFileName);
  }
  if (0 != (setvbuf(pDoc->fDocOut,szBuffer,_IOFBF,131072))) {
    ERRMSGFS(5,"%s: cannot setvbuf for output file %s.",
	     pszFileName);
  }

  /***/ /* should write the <? ... > here.. better... */
  if (pDoc->szXML != NULL) {
    fprintf(pDoc->fDocOut,"%s",pDoc->szXML);
  }
  else {
    fclose(pDoc->fDocOut);
    pDoc->fDocOut = NULL;
    free(szBuffer);
    ERRMSGFS(3,"%s: Internal error; no XML start, file %s.",
	     pDoc->pszCurrentFile);
  }
  /***/ /* should write the <!DOCUMENT... > here, better... */
  if (pDoc->szDocument != cNULL) {
    fprintf(pDoc->fDocOut,"%s",pDoc->szDocument);
  }
  if (0 != (iRC = b4302WriteLevel(pDoc,pDoc->pRoot->pDown,0,0))) {
    fclose(pDoc->fDocOut);
    pDoc->fDocOut = NULL;
    free(szBuffer);
    ERRMSGFS(2,"%s: cannot write document to output file %s.",
	     pDoc->pszCurrentFile);
  }
  fprintf(pDoc->fDocOut,"\n");
  fclose(pDoc->fDocOut);
  pDoc->fDocOut = NULL;
  free(szBuffer);
  return 0;
} /* of b4302WriteFile */

b4302DocType *b4302ParseFile(char *pszFileName, b4302IOOptionsType *po)
{
  b4302DocType *ret;

  if ( b4302ReadFile(&ret, pszFileName, po)==0 )
    return ret;
  else 
    return (b4302DocType *)NULL;
} /* of b4302ParseFile */


char *b4302GetElementName(b4302ElemType *pElem) {
  if (pElem) {
    return pElem->pszName;
  } else {
    return (char *)NULL;
  }
} /* of b4302GetElementName */

b4302DocType *b4302ParseString(char *pszStringXML, b4302IOOptionsType *po)
{
  /* parses string pszStringXML instead of a file */
  /* for parsing a file, see b4302ParseFile */
int iRC;
b4302DocType *pDoc;

YY_BUFFER_STATE handle;
  
  if (b4302fParsing == 1) {
    ERRMSG(pdNULL,"cannot parse string when parsing something else.");
  }

  pDoc = NULL; /* always allocate new Doc; caller
                    should make sure there is no memory leak! */
  if (0 != (iRC = b4302AllocateDoc(&pDoc))) {
    ERRMSG(pdNULL,"cannot allocate document record in ParseString.");
  }

  handle = yy_scan_string((const char *)pszStringXML); /* will bomb inside 
                                            if not enough memory */

  BEGIN(INITIAL); /* reset scanner state */
  pDoc->fDocIn = NULL; /* flex's input file: none here */
  pDoc->pszCurrentFile = "/STRING/";

  memcpy(pDoc->poCurr,po,sizeof(b4302IOOptionsType)); /* set options */

  b4302fParsing = 1; /* now cannot open another file/string for reading */

  iRC = b4302ParseInput(pDoc); /* parse here; yylex knows it should
				  get input from buffer handle not file yyin */

  yy_delete_buffer(handle); /* delete the buffer; I hope that's all to free
			       here... */
  b4302fParsing = 0; /* can open another file/set string */

  if (iRC == 0) {
    return pDoc;
  }
  else {
    return (b4302DocType *) NULL;
  }
} /* of b4302ParseString */

b4302ElemType *b4302DocParseString(b4302DocType *pd, char *pszStringXML)
{
  /* parses string pszStringXML, instead of a file,
     in the context of an already existing document, using its options */
  /* (for parsing a file, see b4302ParseFile) */
int iRC;
b4302DocType *pdClone;
b4302ElemType *peNewVirtualRoot;

YY_BUFFER_STATE handle;
  
  if (b4302fParsing == 1) {
    ERRMSG(peNULL,"cannot parse string when parsing something else.");
  }

  pdClone = NULL; /* always allocate new Doc; caller
                     should make sure there is no memory leak! */
                  /* however, pdClone memory released below */
  if (0 != (iRC = b4302AllocateDoc(&pdClone))) {
    ERRMSG(peNULL,"cannot allocate document record in DocParseString.");
  }
  
  /* clone the document into newly allocated structure: */
  memcpy((void *)pdClone,(const void *)pd,sizeof(b4302DocType));
  /* NB: poCurr not copied --> addresss points to same mem area as orig */
  /* which is ok because we only need pdClone temporarily */

  handle = yy_scan_string((const char *)pszStringXML); /* will bomb inside 
                                            if not enough memory */

  BEGIN(INITIAL); /* reset scanner state */
  pdClone->fDocIn = NULL; /* flex's input file: none here */
  pdClone->pszCurrentFile = "/STRING/";

  b4302fParsing = 1; /* now cannot open another file/string for reading */

  iRC = b4302ParseInput(pdClone); /* parse here; yylex knows it should get
				     input from buffer handle not file yyin */

  yy_delete_buffer(handle); /* delete the buffer; I hope that's all to free
			       here... */
  b4302fParsing = 0; /* can open another file/set string */


  if (iRC == 0) {
    /* link new "document" as fragment of original document only: */
    peNewVirtualRoot = pdClone->pRoot;
    PUSH_FRAGMENT(pd,peNewVirtualRoot);
    /* release memory of pdClone (ignore counts etc. for now) */
    free(pdClone);
    return peNewVirtualRoot->pDown; /* this is the actual root */
  }
  else { /* parsing error */
    free(pdClone);
    return peNULL;
  }
} /* of b4302DocParseString */

char *
b4302StringOfElement(b4302ElemType *pe)
{
  /* get string value of element (as defined in XPath): concat all
     text/CDATA child nodes of pe; no conversion or anything; return cNULL
     on error (or unsuitable parameter pe), empty string if 
     no text descendants. 
     Caller must free memory (except for zero length string 
     - it must *not* free such string) */

b4302ElemType *peCurr;
char *pszResult;
char *pszText;
int cResultLength; /* length of result */ 
int cResultRemaining; /* remaining length of result */ 
char *pszResultFree; /* start of free zone at the end of current result */
int iRC;


#define APPEND(rc,s) if (0 != (iRC = b4302AddSZ(&pszResult,&cResultLength,\
			&pszResultFree,&cResultRemaining,s,strlen(s)))) {\
                        ERRMSGFS(rc,"%s: cannot add str %s.",s); }
  if (pe == peNULL ||
      !b4302NodeIsElement(pe)) {
    return cNULL;
  }
  peCurr = pe->peDown;
  pszResult = "";
  while (peCurr != peNULL) {
    if (b4302NodeIsText(peCurr) ||
        b4302NodeIsCDATA(peCurr)) { /* is text node */
      pszText = (char *) peCurr->peDown; /* get text node's string */
      if (*pszText != '\0') { /* nonempty text */
        if (*pszResult == '\0') { /* empty so far */
	  pszResult = cNULL;
	}
	APPEND(cNULL,pszText);
      }
    } /* of if text node */
    peCurr = peCurr->peNext;
  }
  return pszResult;

#undef APPEND

} /* of b4302StringOfElement */

int b4302ToStringInternal(b4302ElemType *pe,
			  char **pszStart, int *pcCurrentLength,
			  char **ppszFree, int *pcRemaining) 
{
int iRC;
b4302ElemType *peCurr;
b4302AttrType *paCurr;
int fElementNode;
char *pszText;

#define APPEND(rc,s) if (0 != (iRC = b4302AddSZ(pszStart,pcCurrentLength,\
			ppszFree,pcRemaining,s,strlen(s)))) {\
                        ERRMSGFS(rc,"%s: cannot add str %s.",s); }
 

  /* serializes subtree rooted in pe */
  if (pe == peNULL) { /* just to be sure... */
    return 0;
  }
  fElementNode = b4302NodeIsElement(pe);
  if (fElementNode) { /* not a text */
    APPEND(1,"<");
    APPEND(2,pe->pszName);
    /* fprintf(pDoc->fDocOut,"<%s",pElem->pszName); /* tag name */
    /* print attributes if any: */
    paCurr = pe->pAttrFirst;
    while (paCurr != NULL) {
      /***/ /* entitites inside value, char coding! */
      APPEND(3," ");
      APPEND(4,paCurr->pszName);
      APPEND(5,"=\"");
      /* temp: */ /***/
      if (0 != (iRC = b4302AttrValueToString(paCurr->pszValue,
					     pszStart,pcCurrentLength,
					     ppszFree,pcRemaining))) {
	ERRMSGFS(6+10*iRC,"%s: cannot add attr val %s.",paCurr->pszValue);
      }
      APPEND(7,"\"");
      /*
      if (0 != (iRC = b4302WriteAttrValue(pDoc,paCurr->pszValue))) {
	fprintf(stderr,"%s: cannot convert attr value - too long?: %s\n",
		MODULE,paCurr->pszValue);
      }
      */
      paCurr = paCurr->pNext;
    } /* of printing attributes */
    if (pe->pDown == NULL) {
      APPEND(7,"/>"); /* empty tag */
      if (b4302NodeIsVirtualRoot(pe->pParent)) { /***/ /* noblanks? */
	APPEND(8,"\n");
      }
    }
    else {
      APPEND(9,">");
      peCurr = pe->pDown;
      while (peCurr != NULL) {

	if (0 != (iRC = b4302ToStringInternal(peCurr,pszStart,pcCurrentLength,
					      ppszFree,pcRemaining))) {
	  ERRMSGFSD(10,"%s: cannot serialize %s, ret code %d.\n",
		    peCurr->pszName,iRC);
	}
	peCurr = peCurr->pNext; /* next on level */
      } /* of writing out one level */
      APPEND(11,"</");
      APPEND(12,pe->pszName);
      APPEND(13,">");
      APPEND(21,"\n");
    } /* of nonempty tag */
  } /* of not a text node */
  else { /* text or comment or CDATA node */
    if (b4302NodeIsText(pe)) {
      pszText = (char *) pe->pDown; /* re-typecast to string */
      if (0 != (iRC = b4302TextToString(pszText,
					pszStart,pcCurrentLength,
					ppszFree,pcRemaining))) {
	ERRMSGFSD(14,"%s: cannot serialize text %s, ret code %d.\n",
		  pszText,iRC);
      }
    }
    else if (b4302NodeIsComment(pe)) {
      pszText = (char *) pe->pDown; /* re-typecast to string */
      APPEND(15,"<!--");
      APPEND(16,pszText);
      APPEND(17,"-->");
    }
    else if (b4302NodeIsCDATA(pe)) {
      pszText = (char *) pe->pDown; /* re-typecast to string */
      APPEND(18,"<![DATA[");
      APPEND(19,pszText);
      APPEND(20,"]]>");
    }
  }
  return 0;

#undef APPEND

} /* of b4302ToStringInternal */

char *b4302ToString(b4302ElemType *pe)
{
  /* serializes subtree rooted in pe */
char *szResultString; /* resulting serialized string, allocated gradually
			 in global area */
int cResultLength; /* length of result */ 
int cResultRemaining; /* remaining length of result */ 
char *pszResultFree; /* start of free zone at the end of current result */
int iRC;

  if (pe == peNULL) {
    return cNULL;
  }
  szResultString = cNULL; 
  iRC = b4302ToStringInternal(pe,&szResultString,&cResultLength,
			      &pszResultFree,&cResultRemaining);
  if (iRC != 0) {
    ERRMSGFS(cNULL,"%s: error serializing element %s.",pe->pszName);
  }
  if (((cResultRemaining << 7) / cResultLength) > 12) { /* about 10% is ok */
    /****/ /* fprintf(stderr,"reallocating from %d down to %d.\n",
		   cResultLength+cResultRemaining,cResultLength); /**/
    szResultString = (char *) realloc(szResultString,
				      sizeof(char)*(cResultLength + 1));
    if (szResultString == cNULL) {
      ERRMSG(cNULL,"Fatal when truncating string in ToString.");
    }
  }
  return szResultString;
} /* of b4302ToString */

#undef MODULE
